
#include "txml.h"


/**
@brief   Tiny XML Cu 
@file    txml.c
@version 1.0
@author  Fumi.Iseki (C)
@date    2009 2/10

@par ^Cg
TuZbg `XML ȈՃp[T

@attention
SẴp^[̃p[X\͕ۏႵȂD@n
G XML̓p[XłȂD@n
<?xml ... ?> ȊO <? ..... ?>  <! ..... > ͏Ȃiǂݍ݂͍sj@n
GeBeB͏ȂD@n

@see     tXML
*/



//////////////////////////////////////////////////////////////////////////////////////////////////////
//
// Parser
//

/**
tXML*  xml_parse(char* pp)

XMLf[^߂āCtXML̃c[𐶐D

@param  pp   XMLf[^ւ̃|C^D

@return XMLf[^i[ tXML̃AJ[ւ̃|C^D
@return G[̏ꍇCnextȉ̃m[hɂ̓G[NO܂ł̓eۑ
@retval 0ȉ G[Nꍇ state XML_PARSEDȊO̒li0ȉjD

@code
tXML* xml = xml_parse("<a t=\"x\"><b>aaaa<d>bbbb</d>cccc<xxxi/>ddddd</b><c><e></e></c></a>");
@endcode
*/
tXML*  xml_parse(char* pp)
{
	tXML* xml;
	tXML* tag;

	xml = new_xml_node();					// AJ[
	xml->ldat.id = XML_ANCHOR_TAG;

	// p[X
	tag = xml_main_parse(xml, pp, TRUE);
	if (tag->state<0) return xml;


	// ɖ߂H
	if (xml==tag) {
		xml->state = XML_PARSED;
	}
	else {
        xml->state = XML_NOT_CLOSED;
	}

	// XML root̐
	if (xml->next!=NULL) {
		int n = 0;
		tag = xml->next;
		while(tag!=NULL) {
			if (tag->ldat.id==XML_TAG_NAME) n++;
			tag = tag->ysis;
		}
		if (n!=1) xml->state = XML_MULTI_ROOT;
	}
	else xml->state = XML_DEFAULT_STATE;

	return xml;
}



/**
tXML*  xml_parse_file(const char* fn)

t@CǂݍŃp[XD

@param  fn  ǂݍރt@C
@return XMLf[^i[ tXML̃AJ[ւ̃|C^ 
*/
tXML*  xml_parse_file(const char* fn)
{
	tXML*  xml = NULL;
	Buffer buf;

	buf = read_Buffer_file(fn);
	if (buf.buf!=NULL) {
		xml = xml_parse((char*)(buf.buf));
		free_Buffer(&buf);
	}

	return xml;
}



/**
tXML*  xml_parse_seq(tXML* xml, char* pp)

I XMLf[^߂āCtXML̃c[\Ɋi[D
S XMLf[^łȂĂ߂łƂ܂ł͉߂D@n
xml NULL̏ꍇ͎IɃc[D
fГI XMLf[^͂ꍇɎgpD

@param  xml  XMLf[^i[c[\̂̐擪ւ̃|C^Dc[̓r̃^Oł
@param  pp   XMLf[^ւ̃|C^D

@return XMLc[f[^̃AJ[ւ̃|C^
@return @b altp ɍŌɏ^Oւ̃|C^i[D
@return ߂sS̏ꍇ @b state ɏԂ̒lD

@code
    tXML* xml;
    xml = xml_parse_seq(NULL, "<A aaa=\"YYY\"><B>");
    xml = xml_parse_seq(xml->altp, "<Z zzz=\"99 9\"/><M>MM</M></B><C><M><X>XX</X><YY yyy=\"888\">XX");
    xml = xml_parse_seq(xml->altp, "YY</YY>MM</M><C bbb=\"777\" xxx=\"000i\" xxxx=\"000\" >");
    xml = xml_parse_seq(xml->altp, "<X></X><M><X></X>YY<Y>oooo");
    xml = xml_parse_seq(xml->altp, "</Y></M></C></C></A>");
    xml = xml_parse_seq(xml->altp, "<M>");
    close_xml(xml);
@endcode
*/
tXML*  xml_parse_seq(tXML* xml, char* pp)
{
	int   skip = FALSE;
	tXML* tag;

	if (xml==NULL) {
		xml = new_tTree_node();
		xml->ldat.id = XML_ANCHOR_TAG;
		skip = TRUE;
	}
	else {
		tXML* top = find_xml_top(xml);
		if (top==xml) top->state = XML_DEFAULT_STATE;
	}

	tag = xml_main_parse(xml, pp, skip);
	xml = find_xml_top(xml);
	xml->altp = tag;

	if (xml!=tag) return xml;

	if (tag->state==0) xml->state = XML_PARSED;
	else			   xml->state = tag->state;

	if (xml->next!=NULL) {
		int n = 0;
		tag = xml->next;
		while(tag!=NULL) {
			if (tag->ldat.id==XML_TAG_NAME) n++;
			tag = tag->ysis;
		}
		if (n!=1) xml->state = XML_MULTI_ROOT;
	}
	else xml->state = XML_DEFAULT_STATE;

	return xml;
}



/**
tXML*  xml_main_parse(tXML* xml, char* pp, int skip)

I XMLf[^߂āCtXML̃c[\Ɋi[D
S XMLf[^łȂĂ߂łƂ܂ł͉߂D@n
p[T̃C֐DC[Uڂ̊֐gp邱Ƃ͑D

@param  xml   XMLf[^i[c[\̂̐擪ւ̃|C^D
@param  pp    XMLf[^ւ̃|C^D
@param  skip  ŏ̃f[^i^CgȂǁjXLbv邩H TRUE or FLASE

@return Ōɏ^Om[hւ̃|C^DppNULL̏ꍇ xml, xml NULL̏ꍇ NULLԂD
@retval 0 @b state G[̏ꍇ state 0̒lD
*/
tXML*  xml_main_parse(tXML* xml, char* pp, int skip)
{
	int   n, tag_end;
	char* tag_name = NULL;
	char* tag_attr = NULL;
	char* value	   = NULL;
	
	if (pp ==NULL) return xml;
	if (xml==NULL) return NULL;

	if (skip) while (*pp!='\0' && *pp!='<') pp++;

	while (*pp!='\0') {
		n = 1;

		if (*pp=='<') {
			// End TAG		</   >
			if (*(pp+1)=='/') {
				if (xml->state==XML_TAG_STARTED) {
					n = xml_parse_end_tag(pp, &tag_name);
					if (n>0) {
						if (tag_name!=NULL && xml->ldat.key.buf!=NULL) {
							if (!strcmp((const char*)tag_name, (const char*)(xml->ldat.key.buf))) {
								if (xml->next!=NULL) {
									xml->state = XML_TAG_ENDED;
								}
								else {
									xml->state = XML_TAG_EMPTY;
								}
								//
								if (xml->prev!=NULL) xml = xml->prev;
								else n = xml->state = XML_SEQUENCE_ERROR;
							}
							else n = xml->state = XML_PARSE_ERROR;
						}
						else n = xml->state = XML_PARSE_ERROR;
					}
					else xml->state = n;					// G[
				}
				else n = xml->state = XML_PARSE_ERROR;
			}


			// Comment TAG		<!--   -->
			else if (!strncmp(pp+1, "!--", 3)) {
				n = xml_parse_comment_tag(pp, &value);
				if (n>0) {
					xml = add_tTree_node_bystr(xml, XML_COMMENT_TAG, 0, (char*)XML_COMMENT_TAG_KEY, value, NULL, 0);
					xml->state = XML_TAG_EMPTY;
					if (xml->prev!=NULL) xml = xml->prev;
					else n = xml->state = XML_SEQUENCE_ERROR;
				}
			}


			// Data TAG			<!     >
			else if (*(pp+1)=='!') {
				n = xml_parse_data_tag(pp, &value);
				if (n>0) {
					xml = add_tTree_node_bystr(xml, XML_DATA_TAG, 0, (char*)XML_DATA_TAG_KEY, value, NULL, 0);
					xml->state = XML_TAG_EMPTY;
					if (xml->prev!=NULL) xml = xml->prev;
					else n = xml->state = XML_SEQUENCE_ERROR;
				}
			}


			// Processing TAG  	<?   ?>
			else if (*(pp+1)=='?') {
				n = xml_parse_processing_tag(pp, &tag_name, &tag_attr);
				if (n>0) {
					if (!strncasecmp("xml", tag_name, 3)) {
						tList* lp = xml_parse_attr(tag_attr);
						xml = add_tTree_node_bystr(xml, XML_DOC_TAG, 0, tag_name, NULL, NULL, 0);
						xml->ldat.lst = lp;
					}
					else {
						xml = add_tTree_node_bystr(xml, XML_PROCESS_TAG, 0, tag_name, tag_attr, NULL, 0);
					}
					xml->state = XML_TAG_EMPTY;
					if (xml->prev!=NULL) xml = xml->prev;
					else n = xml->state = XML_SEQUENCE_ERROR;
				}
			}


			// Start TAG  <   > 
			else {
				n = xml_parse_start_tag(pp, &tag_name, &tag_attr, &tag_end);

				if (n>0) {
					tList* lp = xml_parse_attr(tag_attr);
					xml = add_tTree_node_bystr(xml, XML_TAG_NAME, 0, tag_name, NULL, NULL, 0);
					xml->ldat.lst = lp;

					if (tag_end) {
						xml->state = XML_TAG_EMPTY;
						if (xml->prev!=NULL) xml = xml->prev;
						else n = xml->state = XML_SEQUENCE_ERROR;
					}
					else {
						int m;
						xml->state = XML_TAG_STARTED;
						// ^Ol
						m = xml_parse_content(pp+n, &value);			// 0 Ԃ\
						if (m>=0) {
							n += m;
							if (value!=NULL) {
								xml = add_tTree_node_bystr(xml, XML_TAG_CONTENT, 0, value, NULL, NULL, 0);
								xml->state = XML_TAG_ENDED;
								if (xml->prev!=NULL) {
									xml = xml->prev;
									xml->ldat.lv++;
								}
								else n = xml->state = XML_SEQUENCE_ERROR;
							}
						}
						else n = xml->state = m;					// G[
					}
				}
			}


			freeNull(tag_name);
			freeNull(tag_attr);
			freeNull(value);
		}


		// Content		(fГIɓ͂XML content ̓rŏIĂꍇȂ)
		else {
			if (xml->state==XML_TAG_STARTED) {
				n = xml_parse_content(pp, &value);
				if (n>0) {
					if (value!=NULL) {
						xml = add_tTree_node_bystr(xml, XML_TAG_CONTENT, 0, value, NULL, NULL, 0);
						xml->state = XML_TAG_ENDED;
						if (xml->prev!=NULL) {
							xml = xml->prev;
							xml->ldat.lv++;
						}
						else n = xml->state = XML_SEQUENCE_ERROR;
					}
				}
				else n = xml->state = XML_PARSE_ERROR;
				freeNull(value);
			}
			else n = xml->state = XML_PARSE_ERROR;
		}


		// G[
		if (n<=0) return xml;

		pp += n;
		while (*pp==' ' || *pp==CHAR_TAB || *pp==CHAR_LF || *pp==CHAR_CR) pp++;
	}

	return xml;
}




///////////////////////////////////////////////////////////////////////////////////////////////////////
//
// Paese of TAG
// 

/**
int  xml_parse_start_tag(char* pp, char** tag_name, char** tag_attr, int* tag_end)

XML̊Jn^ODł^Ǒ^
@code
<tag_name attr1="value1" attr2="value2">
<tag_name attr1="value1" attr2="value2" />
@endcode

@attention
j̊֐ł́C(*tag_attr)̉߂͍sȂ̂ŁC xml_parse_attr() ōsKvD

@param      pp            ^Oւ̃|C^D'<' w|C^D
@param[out] *tag_name     ^O̖Oi[|C^Dv free
@param[out] *tag_attr     ^Ȏi[|C^Di߁j͍sȂDv free
@param[out] *tag_end      ^OPƂŕĂꍇ(Empty Tag) TRUE, łȂꍇ FALSEi[Dv free

@retval  1ȏ            ^OŜ̒D0 Ԃ邱Ƃ͖D
@retval  XML_PARSE_ERROR  p[XG[
@retval  XML_MEMORY_ERROR G[
*/
int  xml_parse_start_tag(char* pp, char** tag_name, char** tag_attr, int* tag_end)
{
	int   nn, mm;
	char* pt;

	*tag_end  = FALSE;
	*tag_name = NULL;
	*tag_attr = NULL;

	if (*pp!='<') return XML_PARSE_ERROR;
	pt = pp = pp + 1;
	pt = skip_char(pt, " />");
	if (pt==NULL) return XML_PARSE_ERROR;

	nn = mm = (int)(pt - pp);
	if (mm==0) return XML_PARSE_ERROR;

	nn = nn + 1;
	*tag_name = (char*)malloc((size_t)(mm + 1));
	if (*tag_name==NULL) return XML_MEMORY_ERROR;
	memcpy(*tag_name, pp, mm);
	(*tag_name)[mm] = '\0';
	//print_message("START --> %s  %d\n", *tag_name, (int)strlen(*tag_name));

	if (isnot_xml_name((unsigned char*)*tag_name)) return XML_PARSE_ERROR;

	// Empty TAG
	if (*pt=='/') {
		if (*(pt+1)!='>') {
			freeNull(*tag_name);
			return XML_PARSE_ERROR;
		}
		nn += 1;
		*tag_end = TRUE;
		//print_message("END   --> %s  %d\n", *tag_name, (int)strlen(*tag_name));
	}

	// Attribute
	else if (*pt==' ') {
		pp = pt = pt + 1;
		while (*pt==' ' || *pt==CHAR_TAB || *pt==CHAR_LF || *pt==CHAR_CR) pt++;
		nn += (int)(pt - pp) + 1;

		pp = pt;
		pt = skip_char(pt, "/>");
		if (pt==NULL) {
			freeNull(*tag_name);
			return XML_PARSE_ERROR;
		}

		mm = (int)(pt - pp);
		if (mm>0) {
			*tag_attr = (char*)malloc((size_t)(mm + 1));
			if (*tag_attr==NULL) {
				freeNull(*tag_name);
				return XML_MEMORY_ERROR;
			}
			memcpy(*tag_attr, pp, mm);
			(*tag_attr)[mm] = '\0';
			nn += mm;
			//print_message("ATTR  --> %s  %d\n", *tag_attr, (int)strlen(*tag_attr));
		}

		if (*pt=='/') {
			if (*(pt+1)!='>') {
				freeNull(*tag_name);
				freeNull(*tag_attr);
				return XML_PARSE_ERROR;
			}
			nn += 1;
			*tag_end = TRUE;
			//print_message("END   --> %s  %d\n", *tag_name, (int)strlen(*tag_name));
		}
	}
	
	//else {}   *pt=='>'

	return nn + 1;
}



/**
int  xml_parse_end_tag(char* pp, char** tag_name)

XML̏I^ODł^Ǒ^ </tag_name>
	
@param      pp           ^Oւ̃|C^D'<' w|C^D
@param[out] *tag_name    ^O̖Oi[|C^Dv free

@retval	1ȏ            ^OŜ̒D0 Ԃ邱Ƃ͖D
@retval XML_PARSE_ERROR  p[XG[
@retval XML_MEMORY_ERROR G[
*/
int  xml_parse_end_tag(char* pp, char** tag_name)
{
	int   nn, mm;
	char* pt;
	char* work;

	if (pp==NULL) return XML_PARSE_ERROR;
	*tag_name = NULL;

	if (strncmp(pp ,"</", 2)) return XML_PARSE_ERROR;

	pt = pp = pp + 2;
	pt = skip_char(pt, ">");
	if (pt==NULL) return XML_PARSE_ERROR;

	nn = mm = (int)(pt - pp);
	if (mm==0) return XML_PARSE_ERROR;

	nn += 2;
	work = (char*)malloc((size_t)(mm+1));
	if (work==NULL) return XML_MEMORY_ERROR;
	memcpy(work, pp, mm);
	work[mm] = '\0';
	*tag_name = pack_head_tail_char(work, ' ');
	free(work);
	//print_message("END   --> %s  %d\n", *tag_name, (int)strlen(*tag_name));

	return nn + 1;
}



/**
int  xml_parse_content(char* pp, char** content)

XML̃RegD <tag_name attr="tag_attr">content</tag_name>@n
l̑Ő󔒁CTAB, LF, CR͍폜D
	
@param      pp           Reg̐擪ւ̃|C^DStart Tag '>' ̎w|C^D
@param[in]	*content     Regi[|C^DRegȂꍇ NULLłD
@param[out]	*content     Regi[DO , TAB, LF, CR͍폜ĂDv free

@retval 0ȏ            ^Ol̑Ŝ̒D0 Ԃ\i<x></x>̏ꍇj
@retval XML_PARSE_ERROR  p[XG[
@retval XML_MEMORY_ERROR G[
*/
int  xml_parse_content(char* pp, char** content)
{
	int   nn=0, mm;
	char* pt;
	char* work;

	if (pp==NULL || content==NULL) return XML_PARSE_ERROR;
	*content = NULL;

	while (*pp==' ' || *pp==CHAR_TAB || *pp==CHAR_LF || *pp==CHAR_CR) {
		pp++;
		nn++;
	}
	if (*pp=='<') return nn;			// <tag><

	pt = pp;
	while (*pt!='<' && *pt!='\0') pt++;

	mm = (int)(pt - pp);
	if (mm==0) return nn;
	nn += mm;

	work = (char*)malloc((size_t)(mm+1));
	if (work==NULL) return XML_MEMORY_ERROR;
	memcpy(work, pp, mm);
	work[mm] = '\0';

	*content = pack_head_tail_char(work, ' ');
	free(work);
	//print_message("VALUE --> %s  %d\n", *content, (int)strlen(*content));

	return nn;
}



/**
tList*  xml_parse_attr(char* pp)

XML̃^O߂āCXg(tList)ɂD ߂`  AAA="GGG" xxxx="1234"

@param  pp  eLXgŕۑĂ鑮ւ̃|C^D

@return Xg̐擪ւ̃|C^D
@retval XML_PARSE_ERROR  @b state p[XG[̏ꍇ state  XML_PARSE_ERROR ݒ肳D
@retval XML_TAG_ENDED    @b state ɏIꍇ XML_TAG_ENDED ݒ肳D
*/
tList*  xml_parse_attr(char* pp)
{
	int	   sz;
	char*  nm;
	char*  vl;
	char*  pt;
	char   qt;
	tList* lp = NULL;
	tList* lt = NULL;


	// ƃ̊m
	if (pp==NULL) return NULL;
	sz = (int)strlen((const char*)pp) + 1;
	nm = (char*)malloc(sz);
	if (nm==NULL) return NULL;
	vl = (char*)malloc(sz);
	if (vl==NULL) {
		free(nm);
		return NULL;
	}

	// Parse for AAA="BBB" CCC="DDDD"
	while (*pp==' ' && *pp!='\0') pp++;
	while (*pp!='\0') {
		pt = pp;
		while (*pt!='=' && *pt!='\0') pt++;
		if (*pt=='\0') {
			if (lt!=NULL) lt->state = XML_PARSE_ERROR;
			break;
		}

		sz = (int)(pt - pp);
		memcpy(nm, pp, (size_t)sz);
		nm[sz] = '\0';

		pt++;
		if (*pt!='"' && *pt!='\'') {
			if (lt!=NULL) lt->state = XML_PARSE_ERROR;
			break;
		}
		else qt = *pt;

		pt++;
		pp = pt;
		while(*pt!=qt && *pt!='\0') pt++;
		if (*pt=='\0') {
			if (lt!=NULL) lt->state = XML_PARSE_ERROR;
			break;
		}

		sz = (int)(pt - pp);
		memcpy(vl+1, pp, (size_t)sz);
		vl[0]	 = qt;
		vl[sz+1] = qt;
		vl[sz+2] = '\0';

		lp = add_tList_node_str(lp, nm, vl);
		if (lt==NULL) lt = lp;
		pp = pt + 1;

		if (*pp!=' ' && *pp!='\0') {
			lt->state = XML_PARSE_ERROR;
			break;
		}
		while (*pp==' ' && *pp!='\0') pp++;
	}

	//
	free(nm);
	free(vl);

	if (lt!=NULL) {
		if (lt->state!=XML_PARSE_ERROR) lt->state = XML_TAG_ENDED;
	}
	return lt;
}



/**
int  xml_parse_processing_tag(char* pp, char** tag_name, char** tag_attr)

XML̃vZbVO^ODł^Ǒ^ <?processing?>@n
vZbVO͉߂ɁĈ܂ tag_name, tag_attrɊi[D

@param      pp           ^Oւ̃|C^D'<' w|C^D
@param[out] *tag_name    vZbVO̖Oi[Dvfree
@param[out] *tag_attr    vZbVȎi[Dvfree

@retval 1ȏ            ^OŜ̒D0 Ԃ邱Ƃ͖D
@retval XML_PARSE_ERROR  p[XG[
@retval XML_MEMORY_ERROR G[
*/
int  xml_parse_processing_tag(char* pp, char** tag_name, char** tag_attr)
{
	int   nn, mm;
	char* pt;

	*tag_name = NULL;
	*tag_attr = NULL;

	if (pp==NULL) return XML_PARSE_ERROR;
	if (strncmp(pp, "<?", 2)) return XML_PARSE_ERROR;

	pt = pp = pp + 2;
	pt = skip_char(pt, " ?");
	if (pt==NULL) return XML_PARSE_ERROR;

	nn = mm = (int)(pt - pp);
	if (mm==0) return XML_PARSE_ERROR;

	nn += 2;
	*tag_name = (char*)malloc((size_t)(mm + 1));
	if (*tag_name==NULL) return XML_MEMORY_ERROR;
	memcpy(*tag_name, pp, mm);
	(*tag_name)[mm] = '\0';

	if (isnot_xml_name((unsigned char*)*tag_name)) return XML_PARSE_ERROR;

	// for attribute
	if (*pt==' ') {
		pp = pt = pt + 1;
		while (*pt==' ' || *pt==CHAR_TAB || *pt==CHAR_LF || *pt==CHAR_CR) pt++;
		nn += (int)(pt - pp) + 1;

		pp = pt;
		pt = skip_char(pt, "?");
		if (pt==NULL) {
			freeNull(*tag_name);
			return XML_PARSE_ERROR;
		}

		mm = (int)(pt - pp);
		if (mm>0) {
			*tag_attr = (char*)malloc((size_t)(mm + 1));
			if (*tag_attr==NULL) {
				freeNull(*tag_name);
				return XML_MEMORY_ERROR;
			}
			memcpy(*tag_attr, pp, mm);
			(*tag_attr)[mm] = '\0';
			nn += mm;
			//print_message("ATTR  --> %s  %d\n", *tag_attr, (int)strlen(*tag_attr));
		}
	}
	
	if (strncmp(pt, "?>", 2)) {
		freeNull(*tag_name);
		freeNull(*tag_attr);
		return XML_PARSE_ERROR;
	}

	return nn + 2;
}



/**
int  xml_parse_comment_tag(char* pp, char** comment)

XML̃Rg^ODł^Ǒ^ '<!--comment-->' @n
xml_parse_data_tag() ɐ旧ēKpKvD

@param      pp	         ^Oւ̃|C^D'<' w|C^D
@param[out] *comment     Rĝ܂܊i[Dv free

@retval 1ȏ            ^OŜ̒D0 Ԃ邱Ƃ͖D
@retval XML_PARSE_ERROR  p[XG[
@retval XML_MEMORY_ERROR G[
*/
int  xml_parse_comment_tag(char* pp, char** comment)
{
	int   nn, mm;
	char* pt;

	*comment = NULL;
	if (pp==NULL) return XML_PARSE_ERROR;
	if (strncmp(pp, "<!--", 4)) return XML_PARSE_ERROR;

	pt = pp = pp + 4;
	pt = skip_char(pt, ">");
	if (pt==NULL) return XML_PARSE_ERROR;

	pt -= 2;
	if (strncmp(pt, "-->", 3)) return XML_PARSE_ERROR;

	nn = mm = (int)(pt - pp);
	if (mm==0) return XML_PARSE_ERROR;

	nn += 4;
	*comment = (char*)malloc((size_t)(mm+1));
	if (*comment==NULL) return XML_MEMORY_ERROR;
	memcpy(*comment, pp, mm);
	(*comment)[mm] = '\0';
	//print_message("COMMENT-> %s  %d\n", *comment, (int)strlen(*comment));

	return nn + 3;
}



/**
int  xml_parse_data_tag(char* pp, char** data)

XML̃f[^^OȋGg^OȂǁjDł^Ǒ^ <!data>@n
f[^͉߂ɁĈ܂ dataɊi[D

@param      pp           ^Oւ̃|C^D'<' w|C^D
@param[out] *data        f[^̂܂܊i[Dv free

@retval 1ȏ            ^OŜ̒D0 Ԃ邱Ƃ͖D
@retval XML_PARSE_ERROR  p[XG[
@retval XML_MEMORY_ERROR G[
*/
int  xml_parse_data_tag(char* pp, char** data)
{
	int   nn, mm;
	char* pt;

	*data = NULL;
	if (pp==NULL) return XML_PARSE_ERROR;
	if (strncmp(pp, "<!", 2)) return XML_PARSE_ERROR;

	pt = pp = pp + 2;
	pt = skip_char(pt, ">");
	if (pt==NULL) return XML_PARSE_ERROR;

	nn = mm = (int)(pt - pp);
	if (mm==0) return XML_PARSE_ERROR;

	nn += 2;
	*data = (char*)malloc((size_t)(mm+1));
	if (*data==NULL) return XML_MEMORY_ERROR;
	memcpy(*data, pp, mm);
	(*data)[mm] = '\0';
	//print_message("DATA ---> %s  %d\n", *data, (int)strlen(*data));

	return nn + 1;
}



/**
int  isnot_xml_name(unsigned char* pp)

XMLƂĕsK؂ǂ܂ɔfD@n
Ȃ肢Ȃ̂ŁCFALSEƂāCXMLƂēK؂łƂ͌ȂD

@param  pp      XMLւ̃|C^
@retval TRUE   XMLƂĕsK
@retval FALSE  XMLƂēK؂Ȃ
*/
int  isnot_xml_name(unsigned char* pp)
{
	if (pp==NULL)  return TRUE;
	if (*pp=='\0') return TRUE;

	while (*pp!='\0') {
		if (*pp<=0x2c) return TRUE;					//  !"#$%&'()*+,
		if (*pp==0x2f) return TRUE;					// /
		if (*pp>=0x3b && *pp<=0x40) return TRUE;	// ;<=>?@
		if (*pp>=0x5b && *pp<=0x5e) return TRUE;	// [\]^
		if (*pp==0x60) return TRUE;					// `
		if (*pp>=0x7b && *pp<=0x7f) return TRUE;	// {|}~DEL
		pp++;
	}
	
	return FALSE;
}



/**
void   close_xml(tXML* pp)
	
p[XG[Nc[Iɐ퉻D

@param pp 퉻c[ւ̃|C^D
*/
void   close_xml(tXML* pp)
{
	if (pp!=NULL) {

		// AJ[
 		if (pp->ldat.id==XML_ANCHOR_TAG) {
			pp->state = XML_PARSED;
			pp->depth = 0;
			if (pp->next!=NULL) {
				pp->next->depth = 1;
				adjust_tTree_depth(pp->next);
				close_xml(pp->next);
			}
			return;
		}

		while(pp->esis!=NULL) pp = pp->esis;
		do {
			if (pp->next==NULL) pp->state = XML_TAG_EMPTY;
			//
			if (pp->state!=XML_TAG_EMPTY) pp->state = XML_TAG_ENDED;
			//if (pp->ldat.lst!=NULL) {
			//	if ((pp->ldat.lst)->state!=XML_TAG_EMPTY) (pp->ldat.lst)->state = XML_TAG_ENDED;
			//}
			//
			if (pp->next!=NULL) close_xml(pp->next);
	   
			pp = pp->ysis;
		} while(pp!=NULL);
	}  
	   
	return;
}






///////////////////////////////////////////////////////////////////////////////////////////////
//
// Inverse Parse
//

/**
Buffer  xml_inverse_parse(tXML* pp, int mode)

ppɊi[ꂽ XMLf[^̏ɖ߂ BufferɊi[Dxml_parse() ̋tD@n
@b XML_CRLF_FORMAT, @b XML_INDENT_FORMAT Ń^Olꍇ́Cl͂ރ^O͉sȂD

@param  pp    XMLf[^̊i[ꂽc[ւ̃|C^
@param  mode  XML֖߂̏
@param  mode  @b XML_ONELINE_FORMAT sȂ̈sɂD
@param  mode  @b XML_CRLF_FORMAT    ^ȌI CR(0x0d), LF(0x0a)ŉsD
@param  mode  @b XML_INDENT_FORMAT  擪ɃCfg(TAB)C^OƂɉs CR LF (0x0d,0x0a)D

@return ϊXMLf[^i[ BufferϐD
*/
Buffer  xml_inverse_parse(tXML* pp, int mode)
{
	int cnt;
	Buffer buf;

	buf = init_Buffer();
	if (pp==NULL) return buf;
	if (pp->ldat.id==XML_ANCHOR_TAG) pp = pp->next;
	if (pp==NULL) return buf;

	cnt = count_tTree(pp);
	buf = make_Buffer(cnt*LPASS);
	if (buf.buf==NULL) return buf;

	while (pp->esis!=NULL) pp = pp->esis;
	xml_to_Buffer(pp, &buf, mode, pp->depth);

	return buf;
}



/**
void   xml_to_Buffer(tXML* pp, Buffer* buf, int mode, int indent)

xml_inverse_parse()p̕⏕֐D
ppɊi[ꂽ XMLf[^̏ɖ߂ BufferɊi[D

@param  pp      XMLf[^̊i[ꂽc[ւ̃|C^
@param  buf     ϊXMLf[^i[ BufferϐD
@param  mode    XML֖߂̏
@param  mode    @b XML_ONELINE_FORMAT sȂ̈sɂD
@param  mode    @b XML_CRLF_FORMAT    ^ȌI CR(0x0d), LF(0x0a)ŉsD
@param  mode    @b XML_INDENT_FORMAT  擪ɃCfg(TAB)C^OƂɉsD
@param  indent  Cfgtn߂[Dmode @b XML_INDENT_MODE ̂Ƃ̂ݗLD
*/
void   xml_to_Buffer(tXML* pp, Buffer* buf, int mode, int indent)
{
	do {
		xml_opentag_to_Buffer(pp, buf, mode, indent);
		if (pp->next!=NULL) {
			xml_to_Buffer(pp->next, buf, mode, indent);
			xml_closetag_to_Buffer(pp, buf, mode, indent);
		}
		
		pp = pp->ysis;
	} while(pp!=NULL);

	return;
}



/**
void   xml_opentag_to_Buffer(tXML* pp, Buffer* buf, int mode, int indent)

c[XML̃I[v^Õf[^̏ɖ߂ BufferɊi[D

@param  pp      XMLf[^̊i[ꂽc[̃m[hւ̃|C^
@param  buf     ϊXMLf[^i[ BufferϐD
@param  mode    XML֖߂̏
@param  mode    @b XML_ONELINE_FORMAT sȂ̈sɂD
@param  mode    @b XML_CRLF_FORMAT    ^ȌI CR(0x0d), LF(0x0a)ŉsD
@param  mode    @b XML_INDENT_FORMAT  擪ɃCfg(TAB)C^OƂɉsD
@param  indent  Cfgtn߂[Dmode XML_INDENT_MODE ̂Ƃ̂ݗLD
*/
void   xml_opentag_to_Buffer(tXML* pp, Buffer* buf, int mode, int indent)
{
	int i;

	// Name TAG
	if (pp->ldat.id==XML_TAG_NAME) {
		if (mode==XML_INDENT_FORMAT || mode==XML_CRLF_FORMAT) {
			if (buf->vldsz!=0 && buf->buf[buf->vldsz-1]!='\n') cat_s2Buffer("\r\n", buf);
		}
		//
		if (mode==XML_INDENT_FORMAT) {
			char* tabs = (char*)malloc(pp->depth-indent+1);
			if (tabs!=NULL) {
				for (i=indent; i<pp->depth; i++) tabs[i-indent] = '\t';
				tabs[pp->depth-indent] = '\0';
				cat_s2Buffer(tabs, buf);
				free(tabs);
			}
		}

		cat_s2Buffer("<", buf);
		cat_Buffer(&(pp->ldat.key), buf);
		if (pp->ldat.lst!=NULL) {
			xml_attr_to_Buffer(pp->ldat.lst, buf);
		}
		if (pp->next==NULL) {
			if (pp->state==XML_TAG_EMPTY) {
				cat_s2Buffer(" />", buf);
			}
			else {
				cat_s2Buffer("></", buf);
				cat_Buffer(&(pp->ldat.key), buf);
				cat_s2Buffer(">", buf);
			}
			if (mode==XML_INDENT_FORMAT || mode==XML_CRLF_FORMAT) {
				cat_s2Buffer("\r\n", buf);
			}
		}
		else {
			cat_s2Buffer(">", buf);
		}
	}
	

	// Content
	else if (pp->ldat.id==XML_TAG_CONTENT) {
		if (buf->buf[buf->vldsz-1]=='\n') {
			buf->buf[buf->vldsz-2] = '\0';
			buf->vldsz -= 2;
		}
		//
		if (pp->esis!=NULL || pp->ysis!=NULL) {
			cat_s2Buffer("\r\n", buf); 
			char* tabs = (char*)malloc(pp->depth-indent+1);
			if (tabs!=NULL) {
				for (i=indent; i<pp->depth; i++) tabs[i-indent] = '\t';
				tabs[pp->depth-indent] = '\0';
				cat_s2Buffer(tabs, buf);
				free(tabs);
			}
		}
		//
		cat_Buffer(&(pp->ldat.key), buf);
		//
		if (pp->esis!=NULL) cat_s2Buffer("\r\n", buf); 
	}


	// xml TAG
	else if (pp->ldat.id==XML_DOC_TAG) {
		if (mode==XML_INDENT_FORMAT) {
			char* tabs = (char*)malloc(pp->depth-indent+1);
			if (tabs!=NULL) {
				for (i=indent; i<pp->depth; i++) tabs[i-indent] = '\t';
				tabs[pp->depth-indent] = '\0';
				cat_s2Buffer(tabs, buf);
				free(tabs);
			}
		}

		cat_s2Buffer("<?", buf);
		if (pp->ldat.key.buf!=NULL) {
			cat_Buffer(&(pp->ldat.key), buf);
		}
		if (pp->ldat.lst!=NULL) {
			xml_attr_to_Buffer(pp->ldat.lst, buf);
		}
		cat_s2Buffer("?>", buf);

		if (mode==XML_INDENT_FORMAT || mode==XML_CRLF_FORMAT) cat_s2Buffer("\r\n", buf);
	}


	// Comment TAG
	else if (pp->ldat.id==XML_COMMENT_TAG) {
		if (mode==XML_INDENT_FORMAT || mode==XML_CRLF_FORMAT) {
			if (buf->buf[buf->vldsz-1]!='\n') cat_s2Buffer("\r\n", buf);
		}

		if (mode==XML_INDENT_FORMAT) {
			char* tabs = (char*)malloc(pp->depth-indent+1);
			if (tabs!=NULL) {
				for (i=indent; i<pp->depth; i++) tabs[i-indent] = '\t';
				tabs[pp->depth-indent] = '\0';
				cat_s2Buffer(tabs, buf);
				free(tabs);
			}
		}

		cat_s2Buffer("<!--", buf);
		if (pp->ldat.val.buf!=NULL) {
			cat_Buffer(&(pp->ldat.val), buf);
		}
		cat_s2Buffer("-->", buf);

		if (mode==XML_INDENT_FORMAT || mode==XML_CRLF_FORMAT) cat_s2Buffer("\r\n", buf);
	}


	// Data TAG
	else if (pp->ldat.id==XML_DATA_TAG) {
		if (mode==XML_INDENT_FORMAT || mode==XML_CRLF_FORMAT) {
			if (buf->buf[buf->vldsz-1]!='\n') cat_s2Buffer("\r\n", buf);
		}
		//
		if (mode==XML_INDENT_FORMAT) {
			char* tabs = (char*)malloc(pp->depth-indent+1);
			if (tabs!=NULL) {
				for (i=indent; i<pp->depth; i++) tabs[i-indent] = '\t';
				tabs[pp->depth-indent] = '\0';
				cat_s2Buffer(tabs, buf);
				free(tabs);
			}
		}

		cat_s2Buffer("<!", buf);
		if (pp->ldat.val.buf!=NULL) {
			cat_Buffer(&(pp->ldat.val), buf);
		}
		cat_s2Buffer(">", buf);

		if (mode==XML_INDENT_FORMAT || mode==XML_CRLF_FORMAT) cat_s2Buffer("\r\n", buf);
	}


	// Processing TAG
	else if (pp->ldat.id==XML_PROCESS_TAG) {
		if (mode==XML_INDENT_FORMAT || mode==XML_CRLF_FORMAT) {
			if (buf->buf[buf->vldsz-1]!='\n') cat_s2Buffer("\r\n", buf);
		}
		//
		if (mode==XML_INDENT_FORMAT) {
			char* tabs = (char*)malloc(pp->depth-indent+1);
			if (tabs!=NULL) {
				for (i=indent; i<pp->depth; i++) tabs[i-indent] = '\t';
				tabs[pp->depth-indent] = '\0';
				cat_s2Buffer(tabs, buf);
				free(tabs);
			}
		}

		cat_s2Buffer("<?", buf);
		if (pp->ldat.key.buf!=NULL) {
			cat_Buffer(&(pp->ldat.key), buf);
		}
		if (pp->ldat.lst!=NULL) {
			xml_attr_to_Buffer(pp->ldat.lst, buf);
		}
		cat_s2Buffer(" ?>", buf);

		if (mode==XML_INDENT_FORMAT || mode==XML_CRLF_FORMAT) cat_s2Buffer("\r\n", buf);
	}


	return;
}



/**
void   xml_closetag_to_Buffer(tXML* pp, Buffer* buf, int mode, int indent)

c[XML̃N[Y^Õf[^̏ɖ߂ BufferɊi[D

@param  pp      XMLf[^̊i[ꂽc[̃m[hւ̃|C^
@param  buf     ϊXMLf[^i[ BufferϐD
@param  mode    XML֖߂̏
@param  mode    @b XML_ONELINE_FORMAT sȂ̈sɂD
@param  mode    @b XML_CRLF_FORMAT    ^ȌI CR(0x0d), LF(0x0a)ŉsD
@param  mode    @b XML_INDENT_FORMAT  擪ɃCfg(TAB)C^OƂɉsD
@param  indent  Cfgtn߂[Dmode XML_INDENT_MODE ̂Ƃ̂ݗLD
*/
void   xml_closetag_to_Buffer(tXML* pp, Buffer* buf, int mode, int indent)
{
	int i;

	if (pp->ldat.id==XML_TAG_NAME) {
		if (pp->next!=NULL) {
			if (mode==XML_INDENT_FORMAT) {
				if (pp->next->ldat.id!=XML_TAG_CONTENT || pp->next->ysis!=NULL) {
					char* tabs = (char*)malloc(pp->depth-indent+1);
					if (tabs!=NULL) {
						for (i=indent; i<pp->depth; i++) tabs[i-indent] = '\t';
						tabs[pp->depth-indent] = '\0';
						cat_s2Buffer(tabs, buf);
						free(tabs);
					}
				}
			}

			cat_s2Buffer("</", buf);
			cat_Buffer(&(pp->ldat.key), buf);
			cat_s2Buffer(">", buf);

			if (mode==XML_INDENT_FORMAT || mode==XML_CRLF_FORMAT) cat_s2Buffer("\r\n", buf);
		}
	}

	return;
}



/**
void   xml_attr_to_Buffer(tList* pp, Buffer* buf)

Xgɕۑꂽ^ȎeLXg֖߂D

@param  pp   f[^i[ꂽXgւ̃|C^D
@param  buf  ϊf[^i[ BufferϐD
*/
void   xml_attr_to_Buffer(tList* pp, Buffer* buf)
{
	while (pp!=NULL) {
		cat_s2Buffer(" ", buf);
		cat_Buffer(&(pp->ldat.key), buf);

		if (pp->ldat.val.buf!=NULL) {
			cat_s2Buffer("=", buf);
			cat_Buffer(&(pp->ldat.val), buf);
		}
		pp = pp->next;
	}
}




///////////////////////////////////////////////////////////////////////////////////////
//
// Operation
//

tXML*  init_xml_doc()
{
	tXML* xml = xml_parse((char*)"<?xml version=\"1.0\" encoding=\"utf-8\"?>");
	return xml;
}



/**
tXML* 	add_xml_tag(tXML* xml, const char* name)

XMLc[xml ̒iöԉFqjɃ^Oi͎w肵Ȃj}D

@param  xml }|Cg
@param  name }^O̖O
@return }^Oւ̃|C^
*/
tXML* 	add_xml_tag(tXML* xml, const char* name)
{
	tList* pp;

	if (xml==NULL || name==NULL) return NULL;

	pp = add_tTree_node_bystr(xml, XML_TAG_NAME, 0, name, NULL, NULL, 0);
	pp->state = XML_TAG_EMPTY;
	if (pp->prev!=NULL) pp->prev->ldat.lv++;

	return pp;
}



/**
tXML* 	insert_xml_tag(tXML* xml, const char* name)

XMLc[xml ̒iöԏFqjɃ^Oi͎w肵Ȃj}D

@param  xml }|Cg
@param  name }^O̖O
@return }^Oւ̃|C^
*/
tXML* 	insert_xml_tag(tXML* xml, const char* name)
{
	tList* pp;

	if (xml==NULL || name==NULL) return NULL;

	pp = insert_tTree_node_bystr(xml, XML_TAG_NAME, 0, name, NULL, NULL, 0);
	pp->state = XML_TAG_EMPTY;
	if (pp->prev!=NULL) pp->prev->ldat.lv++;

	return pp;
}



/**
tXML* 	add_xml_content(tXML* xml, const char* content)

XMLc[xml ̒ɃReg}D@n
Regꍇ͖q̃m[hƂđ}D@n
xml^Om[hłȂ΃G[iNULLԂj
*/
tXML* 	add_xml_content(tXML* xml, const char* content)
{
	tList* pp;

	if (xml==NULL || content==NULL) return NULL;
	if (xml->ldat.id!=XML_TAG_NAME) return NULL;

	pp = add_tTree_node_bystr(xml, XML_TAG_CONTENT, 0, content, NULL, NULL, 0);
	pp->state = XML_TAG_ENDED;
	if (pp->prev!=NULL) pp->prev->ldat.lv++;
  
	return pp;
}



tXML* 	append_xml_content(tXML* xml, const char* content)
{
	tList* pp;

	if (xml==NULL || content==NULL) return NULL;
	if (xml->ldat.id!=XML_TAG_NAME) return NULL;
	
	pp = xml->next;
	while (pp!=NULL && pp->ldat.id!=XML_TAG_CONTENT) pp = pp->ysis;

	if (pp==NULL) {
		pp = add_xml_content(xml, content);
	}
	else {
		if (pp->ldat.key.vldsz!=0) cat_s2Buffer(" ", &(pp->ldat.key));
		cat_s2Buffer(content, &(pp->ldat.key));
	}

	return pp;
}



int  add_xml_content_area(tXML* xml, int len)
{
	if (xml==NULL || len<=0) return FALSE;
	
	char* area = (char*)malloc(len);
	if (area==NULL) return FALSE;
	memset(area, (int)' ', len-1);
	area[len-1] = '\0';

	tXML* pp = add_xml_content(xml, area);
	if (pp!=NULL) {
		pp->ldat.key.buf[0] = '\0';
		pp->ldat.key.vldsz  = 0;
	}
	free(area);

	return TRUE;
}



tXML* 	add_xml_attr(tXML* xml, const char* attr)
{
	if (xml==NULL || attr==NULL) return NULL;
	if (xml->ldat.id!=XML_TAG_NAME) return NULL;

	tList* lp = xml_parse_attr((char*)attr);

	if (xml->ldat.lst==NULL) xml->ldat.lst = lp;
	else add_tList_end(xml->ldat.lst, lp);

	return xml;
}



tXML*   add_xml_attr_str(tXML* xml, const char* name, const char* value)
{
	if (xml==NULL || name==NULL) return NULL;

	Buffer attr = make_xml_attr_str(name, value);
	add_xml_attr(xml, (char*)attr.buf);
	free_Buffer(&attr);

	return xml;
}



tXML*   add_xml_attr_int(tXML* xml, const char* name, int value)
{
	if (xml==NULL || name==NULL) return NULL;
	//
	Buffer attr = make_xml_attr_int(name, value);
	add_xml_attr(xml, (char*)attr.buf);
	free_Buffer(&attr);

	return xml;
}



tXML*   add_xml_attr_float(tXML* xml, const char* name, float value)
{
	if (xml==NULL || name==NULL) return NULL;
	//
	Buffer attr = make_xml_attr_float(name, value);
	add_xml_attr(xml, (char*)attr.buf);
	free_Buffer(&attr);

	return xml;
}



/**
char*   get_first_tag_name(tXML* xml)

XMLc[̍ŏ̃^O̖OԂD

@param  xml  XMLc[
@return XMLc[̍ŏ̃^O̖ODfreeĂ͂ȂD
*/
char*   get_first_tag_name(tXML* xml)
{  
	char* tagname = NULL;
   
	if (xml==NULL) return NULL;
	tList* lp = xml;
	if (lp->ldat.id==XML_ANCHOR_TAG) lp = lp->next;
   
	while (lp!=NULL) {
		if (lp->ldat.id==XML_TAG_NAME) {
			if (lp->ldat.key.buf!=NULL) {
				tagname = (char*)lp->ldat.key.buf;
				break;
			}
		}
		lp = lp->ysis;
	}
	return tagname;
}



Buffer make_xml_attr_bystr(const char* name, const char* value)
{
	Buffer buf = make_Buffer_str(name);
	cat_s2Buffer("=\"", &buf);
	cat_s2Buffer(value, &buf);
	cat_s2Buffer("\"",  &buf);

	return buf;
}



Buffer make_xml_attr_byint(const char* name, int value)
{
	Buffer buf = make_Buffer_str(name);
	cat_s2Buffer("=\"", &buf);
	cat_s2Buffer(itostr(value), &buf);
	cat_s2Buffer("\"",  &buf);

	return buf;
}



Buffer make_xml_attr_byfloat(const char* name, float value)
{
	Buffer buf = make_Buffer_str(name);
	cat_s2Buffer("=\"", &buf);
	cat_s2Buffer(ftostr(value), &buf);
	cat_s2Buffer("\"",  &buf);

	return buf;
}



/**
Regւ̃|C^ԂDfreeĂ͂ȂD
*/
char* xml_get_tag_content(tXML* tag)
{
	if (tag==NULL || tag->next==NULL) return NULL;

	if (tag->ldat.id==XML_TAG_NAME) {
		if (tag->next->ldat.id==XML_TAG_CONTENT) return (char*)(tag->next->ldat.key.buf);
	}
	return NULL;
}



/**
l^Õ|C^Cw肳ꂽlւ̃|C^ԂDfreeĂ͂ȂD

*/
char* xml_get_tag_attr(tXML* tag, const char* attr)
{
	if (tag==NULL) return NULL;

	if (tag->ldat.id==XML_TAG_NAME) {
		tList* lt = tag->ldat.lst;
		while (lt!=NULL) {
			if (!strcmp((const char*)lt->ldat.key.buf, attr)) return (char*)(lt->ldat.val.buf);
			lt = lt->next;
		}
	}
	return NULL;
}



/**
tXML*  dup_merge_xml(tXML* pp, tXML* tp)

XMLc[ pp̒XMLc[ tp𕡐D

@param  pp  ꂽc[̃gbvƂȂm[h
@param  tp  c[

@return ꂽ XMLc[ւ̃|C^D
@return pp NULLłȂꍇ ppDpp NULL̏ꍇ́Ctp𕡐c[̃gbvD
*/
tXML*  dup_merge_xml(tXML* pp, tXML* tp)
{
	tXML* pt;

	if (tp==NULL) return pp;

	if (tp->ldat.id==XML_ANCHOR_TAG) {
		if (tp->next!=NULL) tp = tp->next;
		else return pp;
	}

	pp = dup_merge_tTree(pp, tp);

	if (pp->ldat.id!=XML_ANCHOR_TAG) {
		pt = new_tTree_node();
		pt->ldat.id = XML_ANCHOR_TAG;
		pt->depth = 0;
		add_tTree(pt, pp);
		close_xml(pt);
		return pt;
	}

	return pp;
}



/**
tXML*  del_xml(tXML** pp) 

w肵m[hȉXMLc[ipp̎o͊܂܂Ȃj폜D

@param[in,out]  *pp  폜c[̐擪m[hD폜 NULLɂȂD
@return 폜XMLc[̐em[hւ̃|C^D
*/
tXML*  del_xml(tXML** pp)
{
	tXML* pt;

	if (pp==NULL || *pp==NULL) return NULL;

	// qm[h̍폜
	if ((*pp)->next!=NULL) del_sisters_children_xml(&((*pp)->next));

	// g̍폜
	pt = (*pp)->prev;
	if (pt!=NULL) {
		if (pt->next==*pp) pt->next = (*pp)->ysis;
		if (pt->back==*pp) pt->back = (*pp)->esis;
		pt->num--;
	}
	if ((*pp)->ysis!=NULL) (*pp)->ysis->esis = (*pp)->esis;
	if ((*pp)->esis!=NULL) (*pp)->esis->ysis = (*pp)->ysis;

	free_tListdata(&((*pp)->ldat));
	free(*pp);
	*pp = NULL;

	return pt;
}  



/**
tXML*  del_sister_xml(tXML** pp) 

w肵m[hȉXMLc[ipp̎o܂ށj폜D

@param[in,out]  *pp  폜c[̐擪m[hD폜 NULLɂȂD
@return 폜XMLc[̐em[hւ̃|C^D
*/
tXML*  del_sister_xml(tXML** pp)
{
	tXML* pt;

	if (pp==NULL || *pp==NULL) return NULL;

	pt = (*pp)->prev;
	if (pt!=NULL) {
		pt->next = NULL;
		pt->back = NULL;
		pt->num  = 0;
	}

	del_sisters_children_xml(pp);

	return pt;
}  



/**
tXML*  del_sisters_children_xml(tXML** pp) 

w肵m[h̎oXMLc[CqXMLc[폜Dw肵XMLm[h폜D

@param[in,out]  *pp  폜XMLc[̋N_m[hD폜 NULLɂȂD
@return 폜c[S̐em[hւ̃|C^D

@attention
jċApDem[hɑ΂鏈͍sȂ̂ŁCʓrĂяoōsƁD
*/
tXML*  del_sisters_children_xml(tXML** pp)
{  
	tXML* pm;
	tXML* pt;
   
	if (pp==NULL || *pp==NULL) return NULL;
	pt = (*pp)->prev;
   
	pm = *pp;
	while (pm->esis!=NULL) pm = pm->esis;
	while (pm!=NULL) {
		tXML* pw = pm;
		if (pm->next!=NULL) del_sisters_children_xml(&(pm->next));
		pm = pm->ysis;
		//
		free_tListdata(&(pw->ldat));
		free(pw);
	}
	*pp = NULL;

	pt->next = NULL;
	pt->back = NULL;

	return pt;
}



/**
void  del_all_xml(tXML** pp)

XMLc[̑Sm[h̍폜D|C^ pp̃m[h܂XMLc[Ŝ폜D@n
pp ̓c[ł΁CǂwĂĂǂD

@param[in]  *pp  폜Jnm[hւ̃|C^Dc[ł΁CǂwĂĂǂD
@param[out] *pp  폜 NULLɂȂD
*/
void  del_all_xml(tXML** pp)
{  
	tXML* pm;

	if (pp==NULL || *pp==NULL) return;
   
	pm = *pp;
	while (pm->prev!=NULL) pm = pm->prev;
	del_xml(&pm);

	*pp = NULL;
	return;
}



/**
void   print_xml(FILE* fp, tXML* pp, int mode)
	
XML̕\iójD

@param  fp    o͂t@Cւ̃|C^DNULL̏ꍇ stderr
@param  pp    \JnXML^Oւ̃|C^D
@param  mode  @b XML_ONELINE_FORMAT, @b XML_CRLF_FORMAT, @b XML_INDENT_FORMAT
*/
void   print_xml(FILE* fp, tXML* pp, int mode)
{
	if (fp==NULL) fp = stderr;

	if (pp->ldat.id==XML_ANCHOR_TAG) pp = pp->next;

	if (pp!=NULL) {
		Buffer buf = xml_inverse_parse(pp, mode);
		if (buf.buf!=NULL) {
			fprintf(fp, "%s", buf.buf);
			free_Buffer(&buf);
		}
		else fprintf(fp, "(XML is NULL)\n");
	}  
	else {
		fprintf(fp, "(XML is NULL)\n");
	} 
	fflush(fp);
	   
	return;
}



/**
XML̃m[h\DfobOpD@n

*/
void   print_xml_node(FILE* fp, tXML* pp)
{
	if (fp==NULL) fp = stderr;

	//fprintf(fp, "[: m[h [] ^O ()\n");

	if (pp!=NULL) {
		if (pp->ldat.id==XML_ANCHOR_TAG) pp = pp->next;
		if (pp!=NULL) {
			int num = count_tList((tList*)pp->ldat.lst);
			fprintf(fp, "%d: %d [%d] %s (%d)", pp->depth, pp->ldat.id, pp->state, pp->ldat.key.buf, num);
			fprintf(fp, "\n");
		}
		else {
			fprintf(fp, "(XML is ANCHOR only)\n");
		}
	}  
	else {
		fprintf(fp, "(XML is NULL)\n");
	}  
	fflush(fp);

	return;
}



/**
void   print_xml_tree(FILE* fp, tXML* pp, const char* space)
	
XMLc[̂܂܃c[\DfobOpD@n
|C^ ppȍ~̑SẴ^ÕL[̃obt@WG[o͂ɕ\D@n

\Fq̐[: m[h [m[h] ^O (̌)

@param  fp     o͂t@Cւ̃|C^DNULL̏ꍇ stderr
@param  pp     \Jnm[hւ̃|C^D
@param  space  o𑵂͂̏邽߂̋󔒁iCfgjw肷D "    "
*/
void   print_xml_tree(FILE* fp, tXML* pp, const char* space)
{
	int i;
	if (fp==NULL) fp = stderr;

	//fprintf(fp, "[: m[h [] ^O ()\n");

	if (pp!=NULL) {
		if (pp->ldat.id==XML_ANCHOR_TAG) pp = pp->next;
		if (pp!=NULL) {
			for(i=1; i<pp->depth; i++)   fprintf(fp, space);
			for(i=1; i<pp->depth-1; i++) fprintf(fp, "    ");	   // for " -> "
			print_sister_xml_tree(fp, pp, space);
			fprintf(fp, "\n");
		}
		else {
			fprintf(fp, "(XML is ANCHOR only)\n");
		}
	}  
	else {
		fprintf(fp, "(XML is NULL)\n");
	}  
	fflush(fp);

	return;
}



/**
void   print_sister_xml_tree(FILE* fp, tXML* pp, const char* space)
	
XMLc[̕\Dpp̎om[ho͂D@n
|C^ ppȍ~̑SẴm[h̃L[̃obt@WG[o͂ɕ\D@n
\Fq̐[CID, m[h, ^O(^Ol)C^Ǒ

@param  fp     o͂t@Cւ̃|C^DNULL̏ꍇ stderr
@param  pp	   \Jnm[hւ̃|C^D(om[ho͂j
@param  space  o𑵂͂̏邽߂̋󔒁iCfgjw肷D "    "
*/
void   print_sister_xml_tree(FILE* fp, tXML* pp, const char* space)
{
	if (fp==NULL) fp = stderr;

	if (pp!=NULL) {
		if (pp->ldat.id==XML_ANCHOR_TAG) {
			if (pp->next!=NULL) pp = pp->next;
		}

		while(pp->esis!=NULL) pp = pp->esis;
		//
		while(pp!=NULL) {
			int i;
			tList_data ld = pp->ldat;

		   	if (pp->depth>0) {
				if (pp->esis!=NULL || pp->depth>1) fprintf(fp, "\n");
		   		if (pp->depth>1) {
					for(i=1; i<pp->depth; i++)   fprintf(fp, space);
					for(i=1; i<pp->depth-1; i++) fprintf(fp, "    ");
					fprintf(fp, " -> ");
				}
			}
			int num = count_tList((tList*)ld.lst);
			fprintf(fp, "%d: %d [%d] %s (%d)", pp->depth, ld.id, pp->state, ld.key.buf, num);

			if (pp->next!=NULL) print_sister_xml_tree(fp, pp->next, space);
	   
			pp = pp->ysis;
		};
	}  
	else {
		fprintf(fp, "(XML is NULL)\n");
	} 
	fflush(fp);
	   
	return;
}








////////////////////////////////////////////////////////////////////////////////////////////////
//
// Search and Get/Set
//

/**
tXML*  get_xml_tag(tXML* pp, tXML* pt)

XMLc[ pp XMLc[ ptƓp^[̎}TCptɍŏɈv}́Cpt̍Ō̃m[hɑΉm[hւ̃|C^ԂD@n
pp ̎oc[̂ŒӁD@n

܂Cpt ̒ ctrl  @b TREE_NOCMP_NODE ܂ @b TREE_NOCMP_NODE ƂȂĂ^O͔rȂD@n
ԂĂ tXML*  free Ă͂ȂD

@param  pp  ΏۂXMLc[Doc[D
@param  pt  p^[
@return pt̍Ō̃^OɑΉ^Oւ̃|C^DfreeĂ͂ȂD

@par 
ȉ̏ꍇCpp  A->C->M->X  Xւ̃|C^ԂD
@code
	pp						  pt
	A --> B --> M			  C --> M --> X
	  --> C --> M --> X			   
	  --> Y	--> Z   
			--> N
@endcode
*/
tXML*  get_xml_tag(tXML* pp, tXML* pt)
{
	int fnd;
	tXML* tt;
	tXML* pm;

	if (pp==NULL || pt==NULL) return NULL;

	pm = pp;
	if (pp->ldat.id==XML_ANCHOR_TAG) {
		if (pp->next!=NULL) pp = pp->next;
		else return NULL;
	}
	if (pt->ldat.id==XML_ANCHOR_TAG) {
		if (pt->next!=NULL) pt = pt->next;
		else return NULL;
	}

	tt = find_xml_end(pt);
	if (tt==NULL) return FALSE;

	while(pp->esis!=NULL) pp = pp->esis;
	fnd = find_match_xml(pp, pt);
	if (fnd) tt = tt->altp;
	else     tt = NULL;

	clear_tTree_ctrl(pm);

	return tt;
}



/**
int set_xml_tag(tXML* pp, tXML* pt, const char* name)

XMLc[ pp XMLc[ ptƓp^[̎}TCptɍŏɈv}́Cpt̍Ō̃m[hΉm[hɃ^ORs[D@n
pp ̎oc[̂ŒӁD@n

pt ̒ ctrl  TREE_NOCMP_NODE ܂ TREE_NOCMP_COPY_NODE ƂȂĂ
m[h͔rȂD
	
@param  pp    ΏۂXMLc[Doc[D
@param  pt    p^[
@param  name  pt̍Ō̃^OɑΉ^OɃRs[^OD

@retval TRUE  ݒ肷^Om[hDɐݒꂽǂ͕sD
@retval	FALSE ݒ肷^Om[hȂD
*/
int set_xml_tag(tXML* pp, tXML* pt, const char* name)
{
	tXML* tt;

	if (pp==NULL || pt==NULL || name==NULL) return FALSE;

	tt = get_xml_tag(pp, pt);
	if (tt==NULL) return FALSE;
	
	copy_s2Buffer(name, &(tt->ldat.key));

	return TRUE;
}



/**
int set_xml_end_tag(tXML* pp, tXML* pt)

XMLc[ pp XMLc[ ptƓp^[̎}TCptɍŏɈv}́C
pt̍Ō̃m[hɑΉm[h pt̍Ō̃^O̒li܂ޑjRs[D@n
pp ̎oc[̂ŒӁD@n

Cpt̍Ō̃m[hɊւĂ͔rȂ(Rs[p)D
pt ̒ ctrl  @b TREE_NOCMP_NODE ܂ @b TREE_NOCMP_COPY_NODE ƂȂĂm[h͔rȂD
̃m[h͕KvDRs[ŝ pt̍Ō̃m[ĥ݂łD

Rs[鑮 @b ldat.id, @b ldat.lv, @b ldat.sz, @b ldat.key, l@b dat.val, @b ldat.ptr, @b ldat.lst @n
@b ldat.val, @b ldat.ptr, @b ldat.lst ɂẮCptŒlݒ肳ĂȂ΁CusȂD
	
@param  pp  ΏۂXMLc[Doc[D
@param  pt  p^[

@retval TRUE  ݒ肷}Dɐݒꂽǂ͕sD
@retval	FALSE ݒ肷}ȂD
*/
int set_xml_end_tag(tXML* pp, tXML* pt)
{
	int	  ret;
	tXML* tt;
	tXML* pm;


	if (pp==NULL || pt==NULL) return FALSE;

	pm = pp;
	if (pp->ldat.id==XML_ANCHOR_TAG) {
		if (pp->next!=NULL) pp = pp->next;
		else return FALSE;
	}
	if (pt->ldat.id==XML_ANCHOR_TAG) {
		if (pt->next!=NULL) pt = pt->next;
		else return FALSE;
	}

	tt = find_xml_end(pt);
	if (tt==NULL) return FALSE;
	tt->ctrl = TREE_NOCMP_COPY_NODE;		// ׂȂDŌɃRs[D

	while(pp->esis!=NULL) pp = pp->esis;
	ret = find_match_xml(pp, pt);
	if (ret) {
		copy_tTree_byctrl(pt);
		adjust_tTree_depth(pp);
	}

	clear_tTree_ctrl(pm);

	return ret;
}



/**
tXML*  get_xml_content(tXML* pp, tXML* pt)

XMLc[ pp XMLc[ ptƓp^[̎}TCptɍŏɈv}́C
pt̍Ō̃m[hɑΉm[h̃Regւ̃|C^ԂD@n
pp ̎oc[̂ŒӁD@n

pt ̒ ctrl  TREE_NOCMP_NODE ܂ TREE_NOCMP_COPY_NODE ƂȂĂm[h͔rȂD
̃m[h͕KvD

ԂĂ tXML*  free Ă͂ȂD

@param  pp  ΏۂXMLc[Doc[D
@param  pt  p^[
@return pt̍Ō̃^O̎̃^OɑΉRegւ̃|C^DfreeĂ͂ȂD

@par 
ȉ̏ꍇCZ ւ̃|C^ԂD
@code
	pp						  pt
	A --> B --> M			  C --> M --> Y
	  --> C --> M --> X			   
				  --> Y	--> Z   
			--> N
@endcode
*/
tXML*  get_xml_content(tXML* pp, tXML* pt)
{
	int fnd;
	tXML* tt = NULL;
	tXML* pm;
	tXML* dm;

	if (pp==NULL || pt==NULL) return NULL;

	pm = pp;
	if (pp->ldat.id==XML_ANCHOR_TAG) {
		if (pp->next!=NULL) pp = pp->next;
		else return NULL;
	}
	if (pt->ldat.id==XML_ANCHOR_TAG) {
		if (pt->next!=NULL) pt = pt->next;
		else return NULL;
	}

	tt = find_xml_end(pt);
	if (tt==NULL) return NULL;
	dm = add_xml_content(tt, (char*)"DUMMY");
	if (dm==NULL) return NULL;
	dm->ctrl = TREE_NOCMP_NODE;

	while(pp->esis!=NULL) pp = pp->esis;

	fnd = find_match_xml(pp, pt);
	if (fnd) tt = dm->altp;
	else     tt = NULL;

	del_xml(&dm);
	clear_tTree_ctrl(pm);

	return tt;
}



/**
int set_xml_content(tXML* pp, tXML* pt, const char* content)

XMLc[ pp XMLc[ ptƓp^[̎}TCptɍŏɈv}́C
pt̍Ōm[hɑΉ̃m[h̃Reg contentŒuD
pp ̎oc[̂ŒӁD@n

pt ̒ ctrl  TREE_NOCMP_NODE ܂ TREE_NOCMP_COPY_NODE ƂȂĂm[h
rȂD̃m[h͕KvD
	
@param  pp       Ώۂ̃c[Doc[D
@param  pt       p^[
@param  content  pt̍Ō̃^OɑΉ^OɃRs[^OlD

@retval TRUE     ݒ肷}Dɐݒꂽǂ͕sD
@retval FALSE    ݒ肷}ȂD
*/
int set_xml_content(tXML* pp, tXML* pt, const char* content)
{
	tXML* tt;

	if (pp==NULL || pt==NULL || content==NULL) return FALSE;

	tt = get_xml_content(pp, pt);
	if (tt==NULL) return FALSE;
	
	copy_s2Buffer(content, &(tt->ldat.key));
	return TRUE;
}


/**
int  get_xml_int_content(tXML* pp, tXML* pt)

get_xml_content() gpCXML Rec̓e int^ŕԂD
*/
int  get_xml_int_content(tXML* pp, tXML* pt)
{
	int ret = 0;

	tXML* tag = get_xml_content(pp, pt);
	if (tag!=NULL) ret = atoi((char*)(tag->ldat.key.buf));
	return ret;
}


/**
float  get_xml_float_content(tXML* pp, tXML* pt)

get_xml_content() gpCXML Rec̓e float^ŕԂD
*/
float  get_xml_float_content(tXML* pp, tXML* pt)
{
	float ret = 0.0;

	tXML* tag = get_xml_content(pp, pt);
	if (tag!=NULL) ret = (float)atof((char*)(tag->ldat.key.buf));
	return ret;
}


/**
double  get_xml_double_content(tXML* pp, tXML* pt)

get_xml_content() gpCXML Rec̓e double^ŕԂD
*/
double  get_xml_double_content(tXML* pp, tXML* pt)
{
	double ret = 0.0;

	tXML* tag = get_xml_content(pp, pt);
	if (tag!=NULL) ret = atof((char*)(tag->ldat.key.buf));
	return ret;
}


/**
int  get_xml_char_content(tXML* pp, tXML* pt)

get_xml_content() gpCXML Rec̓e char*^ŕԂDfree Ă͂Ȃ
*/
char*   get_xml_char_content(tXML* pp, tXML* pt)
{
	char* ret = NULL;

	tXML* tag = get_xml_content(pp, pt);
	if (tag!=NULL) ret = (char*)(tag->ldat.key.buf);
	return ret;
}


/**
tList*  get_xml_attr(tXML* pp, tXML* pt)

XMLc[ pp XMLc[ ptƓp^[̎}TCptɍŏɈv}́C
pt̍Ō̃m[hɑΉm[h̃^Olւ̃XgԂD@n
pp ̎oc[̂ŒӁD@n

pt ̒ ctrl  @b TREE_NOCMP_NODE ܂ @b TREE_NOCMP_COPY_NODE ƂȂĂm[h
rȂD̃m[h͕KvD

@param  pp  Ώۂ̃c[Doc[D
@param  pt  p^[
@return pt̍Ō̃^OΉɂCpp̃^ȎliXgj
*/
tList*  get_xml_attr(tXML* pp, tXML* pt)
{
	tList* lp = NULL;
	tXML*  tt;

	if (pp==NULL || pt==NULL) return NULL;

	tt  = get_xml_tag(pp, pt);
	if (tt!=NULL) lp = tt->ldat.lst;	
	return lp;
}


/**
char*  get_xml_char_attr(tXML* pp, tXML* pt, const char* attr)

get_xml_tag() Ō^OCl attr̒l char*^ŎoDfree Ă͂ȂD
*/
char*  get_xml_char_attr(tXML* pp, tXML* pt, const char* attr)
{
	char* ret = NULL;
	if (pp==NULL || pt==NULL || attr==NULL) return ret;

	tXML* tag = get_xml_tag(pp, pt);
	if (tag!=NULL) ret = xml_get_tag_attr(tag, attr);
	return ret;
}


/**
int  get_xml_int_attr(tXML* pp, tXML* pt, const char* attr)

get_xml_tag() Ō^OCl attr̒l int^ŎoD
l " ŊĂĂǂD
*/
int  get_xml_int_attr(tXML* pp, tXML* pt, const char* attr)
{
	int ret = 0;
	if (pp==NULL || pt==NULL || attr==NULL) return ret;

	tXML* tag = get_xml_tag(pp, pt);
	if (tag!=NULL) {
		char* val = xml_get_tag_attr(tag, attr);
		if (val!=NULL) {
			Buffer buf = make_Buffer_bystr(val);
			char* ptr  = (char*)buf.buf;
			if (ptr[strlen(ptr)-1]=='"') ptr[strlen(ptr)-1] = '\0';
			if (ptr[0]=='"') ptr++; 
			ret = atoi(ptr);
			free_Buffer(&buf);
		}
	}
	return ret;
}


/**
double  get_xml_double_attr(tXML* pp, tXML* pt, const char* attr)

get_xml_tag() Ō^OCl attr̒l double^ŎoD
l " ŊĂĂǂD
*/
double  get_xml_double_attr(tXML* pp, tXML* pt, const char* attr)
{
	double ret = 0.0;
	if (pp==NULL || pt==NULL || attr==NULL) return ret;

	tXML* tag = get_xml_tag(pp, pt);
	if (tag!=NULL) {
		char* val = xml_get_tag_attr(tag, attr);
		if (val!=NULL) {
			Buffer buf = make_Buffer_bystr(val);
			char* ptr  = (char*)buf.buf;
			if (ptr[strlen(ptr)-1]=='"') ptr[strlen(ptr)-1] = '\0';
			if (ptr[0]=='"') ptr++; 
			ret = atof(ptr);
			free_Buffer(&buf);
		}
	}
	return ret;
}


/**
int   set_xml_attr(tXML* pp, tXML* pt, tList* at)

XMLc[ pp XMLc[ ptƓp^[̎}TCptɍŏɈv}́C
pt̍Ō̃m[hɑΉm[h̃^ȎƂ at̒lRs[D@n
pp ̎oc[̂ŒӁD@n

pt ̒ ctrl  TREE_NOCMP_NODE ܂ TREE_NOCMP_COPY_NODE ƂȂĂm[h
rȂD̃m[h͕KvD

@param  pp    Ώۂ̃c[Doc[D
@param  pt    p^[
@param  at    ݒ肷鑮̊i[ꂽXgD@b ldat.key ɑC@b ldat.val ɑl("'t)

@retval TRUE  ݒ肷}Dɐݒuꂽǂ͕sD
@retval FALSE ݒ肷}ȂD
*/
int   set_xml_attr(tXML* pp, tXML* pt, tList* at)
{
	tXML* tt;

	if (pp==NULL || pt==NULL || at==NULL) return FALSE;

	tt  = get_xml_tag(pp, pt);
	if (tt!=NULL) {
		del_all_tList(&(tt->ldat.lst));
		tt->ldat.lst = dup_tList(at);
	}
	else return FALSE;
	return TRUE;
}


/**
int	  replace_xml_content(tXML* pp, tXML* pt, const char* src, const char* dst)
*/
int	  replace_xml_content(tXML* pp, tXML* pt, const char* src, const char* dst)
{
	tXML*  tt;
	Buffer tg;

	if (pp==NULL || pt==NULL || src==NULL || dst==NULL) return FALSE;

	tt = get_xml_content(pp, pt);
	if (tt==NULL) return FALSE;

	tg = replace_sBuffer_bystr(tt->ldat.key, src, dst);
	if (tg.buf==NULL) return FALSE;

	free_Buffer(&(tt->ldat.key));
	tt->ldat.key = tg;
	
	return TRUE;
}


/**
tXML*  get_xml_tag_bystr(tXML* pp, const char* str)

get_xml_tag(tXML* pp, tXML* pt)  _bystr o[W
*/
tXML*  get_xml_tag_bystr(tXML* pp, const char* str)
{
	tXML* tx;
	tXML* tt;

	if (pp==NULL || str==NULL) return FALSE;

	tx = xml_parse((char*)str);
	tt = get_xml_tag(pp, tx);
	del_xml(&tx);
	return tt;
}


/**
int  set_xml_tag_bystr(tXML* pp, const char* str, const char* val)

set_xml_tag(tXML* pp, tXML* pt, const char* val)  _bystr o[W
*/
int  set_xml_tag_bystr(tXML* pp, const char* str, const char* val)
{
	tXML*  tx;
	int	rt;

	if (pp==NULL || str==NULL || val==NULL) return FALSE;

	tx = xml_parse((char*)str);
	rt = set_xml_tag(pp, tx, val);
	del_xml(&tx);
	return rt;
}


/**
int  set_xml_end_tag_bystr(tXML* pp, const char* str)

set_xml_end_tag(tXML* pp, tXML* pt)  _bystr o[W
*/
int  set_xml_end_tag_bystr(tXML* pp, const char* str)
{
	tXML*  tx;
	int	rt;

	if (pp==NULL || str==NULL) return FALSE;

	tx = xml_parse((char*)str);
	rt = set_xml_end_tag(pp, tx);
	del_xml(&tx);
	return rt;
}


/**
tXML*  get_xml_content_bystr(tXML* pp, const char* str)

get_xml_content(tXML* pp, tXML* pt)  _bystr o[W
*/
tXML*  get_xml_content_bystr(tXML* pp, const char* str)
{
	tXML* tx;
	tXML* tt;

	if (pp==NULL || str==NULL) return FALSE;

	tx = xml_parse((char*)str);
	tt = get_xml_content(pp, tx);
	del_xml(&tx);
	return tt;
}


/**
int  get_xml_int_content_bystr(tXML* pp, const char* str)

get_xml_int_content(tXML* pp, tXML* pt)  _bystr o[W
get_xml_content()_bystr gpCXML Rec̓e int^ŕԂD
*/
int  get_xml_int_content_bystr(tXML* pp, const char* str)
{
	int ret = 0;

	tXML* tag = get_xml_content_bystr(pp, str);
	if (tag!=NULL) ret = atoi((char*)(tag->ldat.key.buf));
	return ret;
}


/**
float  get_xml_float_content_bystr(tXML* pp, const char* str)

get_xml_float_content(tXML* pp, tXML* pt)  _bystr o[W
get_xml_content_bystr() gpCXML Rec̓e float^ŕԂD
*/
float  get_xml_float_content_bystr(tXML* pp, const char* str)
{
	float ret = 0.0;

	tXML* tag = get_xml_content_bystr(pp, str);
	if (tag!=NULL) ret = (float)atof((char*)(tag->ldat.key.buf));
	return ret;
}


/**
double  get_xml_double_content_bystr(tXML* pp, const char* str);

get_xml_double_content(tXML* pp, tXML* pt)  _bystr o[W
get_xml_content_bystr() gpCXML Rec̓e double^ŕԂD
*/
double  get_xml_double_content_bystr(tXML* pp, const char* str)
{
	double ret = 0.0;

	tXML* tag = get_xml_content_bystr(pp, str);
	if (tag!=NULL) ret = atof((char*)(tag->ldat.key.buf));
	return ret;
}


/**
char*   get_xml_char_content_bystr(tXML* pp, const char* str);

get_xml_char_content(tXML* pp, tXML* pt)  _bystr o[W
get_xml_content_bystr() gpCXML Rec̓e char*^ŕԂD
free Ă͂ȂD
*/
char*   get_xml_char_content_bystr(tXML* pp, const char* str)
{
	char* ret = NULL;

	tXML* tag = get_xml_content_bystr(pp, str);
	if (tag!=NULL) ret = (char*)(tag->ldat.key.buf);
	return ret;
}



/**
int  set_xml_content_bystr(tXML* pp, const char* str, const char* val)

set_xml_content(tXML* pp, tXML* pt, char* val)  _bystr o[W
*/
int  set_xml_content_bystr(tXML* pp, const char* str, const char* val)
{
	tXML*  tx;
	int	rt;

	if (pp==NULL || str==NULL || val==NULL) return FALSE;

	tx = xml_parse((char*)str);
	rt = set_xml_content(pp, tx, val);
	del_xml(&tx);
	return rt;
}


/**
tList*  get_xml_attr_bystr(tXML* pp, const char* str)

get_xml_attr(tXML* pp, tXML* pt)  _bystr o[W
*/
tList*  get_xml_attr_bystr(tXML* pp, const char* str)
{
	tXML*  tx;
	tList* tt;

	if (pp==NULL || str==NULL) return NULL;

	tx = xml_parse((char*)str);
	tt = get_xml_attr(pp, tx);
	del_xml(&tx);
	return tt;
}


/**
char*  get_xml_char_attr_bystr(tXML* pp, const char* str, const char* attr)

get_xml_char_attr()  _bystro[WD
get_xml_tag_bystr() Ō^OCl attr̒l char*^ŎoDfree Ă͂ȂD
*/
char*  get_xml_char_attr_bystr(tXML* pp, const char* str, const char* attr)
{
	char* ret = NULL;
	if (pp==NULL || str==NULL || attr==NULL) return ret;

	tXML* tag = get_xml_tag_bystr(pp, str);
	if (tag!=NULL) ret = xml_get_tag_attr(tag, attr);
	return ret;
}


/**
int  get_xml_int_attr_bystr(tXML* pp, const char* str, const char* attr)

get_xml_int_attr()  _bystro[WD
get_xml_tag_bystr() Ō^OCl attr̒l int^ŎoD
l " ŊĂĂǂD
*/
int  get_xml_int_attr_bystr(tXML* pp, const char* str, const char* attr)
{
	int ret = 0;
	if (pp==NULL || str==NULL || attr==NULL) return ret;

	tXML* tag = get_xml_tag_bystr(pp, str);
	if (tag!=NULL) {
		char* val = xml_get_tag_attr(tag, attr);
		if (val!=NULL) {
			Buffer buf = make_Buffer_bystr(val);
			char* ptr  = (char*)buf.buf;
			if (ptr[strlen(ptr)-1]=='"') ptr[strlen(ptr)-1] = '\0';
			if (ptr[0]=='"') ptr++; 
			ret = atoi(ptr);
			free_Buffer(&buf);
		}
	}
	return ret;
}


/**
double  get_xml_double_attr_bystr(tXML* pp, const char* str, const char* attr)

get_xml_double_attr()  _bystro[WD
get_xml_tag_bystr() Ō^OCl attr̒l double^ŎoD
l " ŊĂĂǂD
*/
double  get_xml_double_attr_bystr(tXML* pp, const char* str, const char* attr)
{
	double ret = 0.0;
	if (pp==NULL || str==NULL || attr==NULL) return ret;

	tXML* tag = get_xml_tag_bystr(pp, str);
	if (tag!=NULL) {
		char* val = xml_get_tag_attr(tag, attr);
		if (val!=NULL) {
			Buffer buf = make_Buffer_bystr(val);
			char* ptr  = (char*)buf.buf;
			if (ptr[strlen(ptr)-1]=='"') ptr[strlen(ptr)-1] = '\0';
			if (ptr[0]=='"') ptr++; 
			ret = atof(ptr);
			free_Buffer(&buf);
		}
	}
	return ret;
}


/**
int  set_xml_attr_bystr(tXML* pp, const char* str, tList* at)

set_xml_attr(tXML* pp, tXML* pt, tList* at)  _bystr o[W
*/
int  set_xml_attr_bystr(tXML* pp, const char* str, tList* at)
{
	tXML* tx;
	int   rt;

	if (pp==NULL || str==NULL || at==NULL) return FALSE;

	tx = xml_parse((char*)str);
	rt = set_xml_attr(pp, tx, at);
	del_xml(&tx);
	return rt;
}


/**
int	  replace_xml_content_bystr(tXML*pp, const char* str, const char* src, const char* dst)

replace_xml_content(tXML*pp, tXML* pt, char* src, char* dst)  _bystr o[W
*/
int	  replace_xml_content_bystr(tXML*pp, const char* str, const char* src, const char* dst)
{
	tXML* tx;
	int   rt;

	if (pp==NULL || src==NULL || src==NULL || dst==NULL) return FALSE;

	tx = xml_parse((char*)str);
	rt = replace_xml_content(pp, tx, src, dst);
	del_xml(&tx);
	return rt;
}




/////////////////////////////////////////////////////////////////////////////////////
// Operation for Multi Tags

/**
tList*  get_xml_tag_list(tXML* pp, tXML* pt)

XMLc[ pp XMLc[ ptƓp^[̎}TCptɈv}́Cpt̍Ō̃m[hɑΉm[hւ
|C^XgɊi[ĕԂD|C^̓Xg altpɊi[D

pt ̒ ctrl  TREE_NOCMP_NODE ܂ TREE_NOCMP_COPY_NODE ƂȂĂm[h
rȂD̃m[h͕KvD

@param  pp  Ώۂ̃c[
@param  pt  p^[
@return Ym[hւ̃|C^(altp)܂񂾃Xgւ̃|C^
*/
tList*  get_xml_tag_list(tXML* pp, tXML* pt)
{
	tList* lp;

	if (pp==NULL || pt==NULL) return NULL;

	if (pp->ldat.id==XML_ANCHOR_TAG) {
		if (pp->next!=NULL) pp = pp->next;
		else return NULL;
	}
	if (pt->ldat.id==XML_ANCHOR_TAG) {
		if (pt->next!=NULL) pt = pt->next;
		else return NULL;
	}

	lp = find_match_xml_endlist(pp, pt);

	return lp;
}



/**
tList*  get_xml_content_list(tXML* pp, tXML* pt)

XMLc[ pp XMLc[ ptƓp^[̎}TCptɈv}́Cpt̍Ō̃m[hɑΉm[h
Regւ̃|C^XgɊi[ĕԂD|C^̓Xg altpɊi[D

pt ̒ ctrl  TREE_NOCMP_NODE ܂ TREE_NOCMP_COPY_NODE ƂȂĂm[h
rȂD̃m[h͕KvD

@param  pp  Ώۂ̃c[
@param  pt  p^[

@return Ym[hւ̃|C^(altp)܂񂾃Xgւ̃|C^
*/
tList*  get_xml_content_list(tXML* pp, tXML* pt)
{
	tList* lp;
	tList* dm;

	if (pp==NULL || pt==NULL) return NULL;

	if (pp->ldat.id==XML_ANCHOR_TAG) {
		if (pp->next!=NULL) pp = pp->next;
		else return NULL;
	}
	if (pt->ldat.id==XML_ANCHOR_TAG) {
		if (pt->next!=NULL) pt = pt->next;
		else return NULL;
	}

	dm = find_xml_end(pt);
	if (dm==NULL) return NULL;
	dm = add_xml_content(dm, (char*)"DUMMY");
	if (dm==NULL) return NULL;
	dm->ctrl = TREE_NOCMP_NODE;

	lp = find_match_xml_endlist(pp, pt);
	del_xml(&dm);

	return lp;
}



/**
int  set_xml_content_list(tXML* pp, tXML* pt, const char* content)

get_xml_content_list() ŌoReg, content ŒuD

@param  pp       ΏۂXMLc[
@param  pt       p^[
@param  content  ̃^Ol  

@return m[ȟ
*/
int  set_xml_content_list(tXML* pp, tXML* pt, const char* content)
{
	int    num = 0;
	tList* lt;
	tList* lp;

	if (pp==NULL  || pt==NULL || content==NULL)  return 0;

	lp = lt = get_xml_content_list(pp, pt);
	if (lt==NULL) return 0;

	while (lt!=NULL) {
		if (lt->altp!=NULL) {
			copy_s2Buffer(content, &(lt->altp->ldat.key));
			num++;
		}
		lt = lt->next;
	}
	del_tList(&lp);

	return num;
}



/**
tList*  get_xml_tag_list_bystr(tXML* pp, const char* str)

*/
tList*  get_xml_tag_list_bystr(tXML* pp, const char* str)
{
	tXML*  tx;
	tList* tt;

	if (pp==NULL || str==NULL) return NULL;

	tx = xml_parse((char*)str);
	tt = get_xml_tag_list(pp, tx);
	del_xml(&tx);

	return tt;
}



/**
tList*  get_xml_conetnt_list_bystr(tXML* pp, const char* str)

*/
tList*  get_xml_content_list_bystr(tXML* pp, const char* str)
{
	tXML*  tx;
	tList* tt;

	if (pp==NULL || str==NULL) return NULL;

	tx = xml_parse((char*)str);
	tt = get_xml_content_list(pp, tx);
	del_xml(&tx);

	return tt;
}



/**
int  set_xml_content_list_bystr(tXML* pp, const char* str, const char* content)

*/
int  set_xml_content_list_bystr(tXML* pp, const char* str, const char* content)
{
	tXML* tx;
	int   rt;

	if (pp==NULL  || str==NULL || content==NULL) return 0;

	tx = xml_parse((char*)str);
	rt = set_xml_content_list(pp, tx, content);
	del_xml(&tx);

	return rt;
}




/////////////////////////////////////////////////////////////////////////////////////////////////////
//
// Search Function for XML
//         tTree p̊֐Ƃقړ
//

/**
int  find_match_xml(tXML* pp, tXML* pt)

c[ pp c[ ptƓp^[̎}TDoc[̂ŒӁD@n 

p^[̒Tł L[l݂̂rCm[hl͔rȂD@n
Cpt->ctrl  TREE_NOCMP_NODE ܂ TREE_NOCMP_COPY_NODE ̃m[hׂ͔Ȃ(ɈvƂ)D
	
c[p^[ꍇCtr̊em[h altpɂ́CԍŏɌΉ pp̊em[h
̃|C^i[D

check_match_xml() Ƃ̈ႢD
- check_match_xml() łׂ͔}̊Jnm[hppɌŒ肳D
- find_match_xml()  ppړȂ猟łD

@param  pp     Ώۂ̃c[Doc[D
@param  pt     p^[̃c[

@retval TRUE   pp ptc[p^[݂D
               pt̊em[h altpɂ́CԍŏɌΉ pp̊em[hւ̃|C^i[D
@retval FALSE  ppɓc[p^[͖D̏ꍇCptaltp̒l͕sƂȂD
*/
int  find_match_xml(tXML* pp, tXML* pt)
{
	int   ret;
	tXML* pm;

	pm = pp;
	while(pp!=NULL) {
		ret = check_match_xml(pp, pt);
		if (ret) return TRUE;

		if (pp->next!=NULL) {
			ret = find_match_xml(pp->next, pt);
			if (ret) {
				clear_tTree_ctrl(pm);
				return TRUE;
			}
		}
		pp = pp->ysis;
	}

	return FALSE;
}



/**
tXML*  find_match_xml_endlist(tXML* pp, tXML* pt)

c[ pp c[ ptƓp^[̎}SĒTāC̎}pt̍Ō̃m[hɑΉm[h̏XgɂĕԂD@n
Ym[hւ̃|C^ ԂꂽeXgaltp ێĂD 

rł L[l݂̂rCm[hl͔rȂD@n
܂Cpt->ctrl  @b TREE_NOCMP_NODE ܂ @b TREE_NOCMP_COPY_NODE ̃m[hׂ͔Ȃ(ɈvƂ)D
	
@param  pp  Ώۂ̃c[Doc[D
@param  pt  p^[̃c[

@return Ym[hւ̃|C^ێ郊XgD
*/
tXML*  find_match_xml_endlist(tXML* pp, tXML* pt)
{
	tXML*  te;
	tList* lp;

	te = find_xml_end(pt);
	while(pp->esis!=NULL) pp = pp->esis;

	lp = find_match_xml_endlist_rcsv(pp, pt, te);
	if (lp!=NULL) clear_tTree_ctrl(pp);
	
	return lp;
}



/**
tList*  find_match_xml_endlist_rcsv(tXML* pp, tXML* pt, tXML* te)

find_match_xml_endlist() ̕⏕֐

*/
tList*  find_match_xml_endlist_rcsv(tXML* pp, tXML* pt, tXML* te)
{
	tList* lt = NULL;
	tList* lp = NULL;
					
	while(pp!=NULL) {			 
		int ret = check_match_xml(pp, pt);
		if (ret && te->altp!=NULL) {
			tList* lm = new_tList_node();
			lm->altp = te->altp;  
			lt = insert_tList(lt, lm);
			if (lp==NULL) lp = lt;
			te->altp = NULL;
		}  
							
		if (pp->next!=NULL) {	 
			tList* lm = find_match_xml_endlist_rcsv(pp->next, pt, te);
			if (lm!=NULL) {	   
				lt = insert_tList(lt, lm);
				if (lp==NULL) lp = lt;
				clear_tTree_ctrl(pp->next);
			}
		}
								   
		if (!ret) pp = pp->ysis;	// ꍇ͂xDȂꍇ֎ցD
	}

	return lp;
}



/**
tXML*  find_match_xml_end_tag(tXML* pp, tXML* pt)

XMLc[ pp XMLc[ ptƓp^[̎}TCpt̍Ō̃^OɑΉ pp̃m[hւ̃|C^ԂD@n
m[h ^OCReĝǂłD

@param  pp  ΏۂXML
@param  pt  p^[̕D
@return str̍Ō̃m[hɑΉ pp̃m[hD
*/
tXML*  find_match_xml_end_tag(tXML* pp, tXML* pt)
{
	int    ret;
	tXML*  tt = NULL;
	tXML*  pm;

	if (pp==NULL || pt==NULL) return NULL;

	pm  = pp;
	ret = find_match_tTree(pp, pt);
	if (ret) {
		tt = find_xml_end(pt);
		if (tt!=NULL) {
			tt = tt->altp;
		}
	}

	clear_tTree_ctrl(pm);

	return tt;
}



/**
int  check_match_xml(tXML* tp, tXML* tr)

XMLc[ tp XMLc[ trƓǂD

tp ̃gbv tr ̃gbv̓L[lvĂKvDvĂȂ΁Cp^[͖ƂD@n
Ctr->ctrl  @b TREE_NOCMP_NODE ܂ @b TREE_NOCMP_COPY_NODE ̃m[hׂ͔Ȃ(ɈvƂ)D

x tp̎}̍Ō̃m[hɑ΂Ă ctrl @b TREE_ALREADY_FOUND_NODE ݒ肷̂ŁCă`FbN
ꍇȂǂ ctrl NAKvD

c[p^[ꍇCtr̊em[h altpɂ́CԍŏɌ
Ή tp̊em[hւ̃|C^i[D

@param  tp     Ώۂ̃c[
@param  tr     p^[̃c[

@retval TRUE   tp trƓc[p^[݂D
@retval TRUE   tr̊em[h altpɂ́CԍŏɌΉ tp̊em[hւ̃|C^i[D
@retval FALSE  tpɓc[p^[͖D̏ꍇCtr altp̒l͕sƂȂD
*/
int  check_match_xml(tXML* tp, tXML* tr)
{
	int   ret;
	tXML* te;
	tXML* ts;

	tXML* tt;
	tXML* ta;
	tXML* tb;


	if (tp==NULL || tr==NULL) return FALSE;

	te = find_tList_end(tr);

	ts = tp;
	while (ts!=NULL) {
		tt = cmp_sisters_xml(ts, tr);		// ̊Kw trƑSĈvĂ镔邩mF
		if (tt==NULL) return FALSE;			// vĂȂ΁CFALSE
		
		ta  = tt;							// ׂc[
		tb  = tr;							// ׂp^[
		ret = TRUE;
		while (tb!=NULL && ret) {
			if (tb->next==NULL) ret = TRUE;
			// ->ta, ->tb->tx: FALSE
			else if (tb->next!=NULL && ta->next==NULL) ret = FALSE;
			// ->ta->xa, ->tb->xb: xaxb`FbN
			else ret = check_match_xml(ta->next, tb->next);

			ta = ta->ysis;
			tb = tb->ysis;
		}

		if (ret) {
			if (tr==te) tt->ctrl = TREE_ALREADY_FOUND_NODE;
			return TRUE;
		}

		ts = tt->ysis;
	}

	return FALSE;
}



/**
tXML*  cmp_sisters_xml(tXML* tp, tXML* tr)

XMLm[h tp̎om[h tr̎om[hƓ XML^O܂̓Regł邩rD

Ctr->ctrl  @b TREE_NOCMP_NODE ܂ @b TREE_NOCMP_COPY_NODE ̃m[hׂ͔Ȃ(ɈvƂ)D@n
܂ tp->ctrl  @b TREE_ALREADY_FOUND_NODE ̏ꍇ́CɈvȂD

m[hp^[ꍇCtr̊em[h altpɂ͑Ή tp̊em[hւ̃|C^i[D@n
܂ tp̊em[h ctrlɂ @b TREE_ALREADY_FOUND_NODE ݒ肳D

@param  tp   ׂom[h̒m[h
@param  tr   Tom[hp^[̒m[h

@return tp trƓp^[n܂m[hւ̃|C^D
        tr̊em[h altpɂ͑Ή tp̊em[hւ̃|C^i[D
@retval NULL tpɓop^[͖D

@par 
ȉ̏ꍇCcmp_sisters_xml(tp, tr)  (3)ւ̃|C^ԂD@n
܂ tr Am[h altp ɂ (3) ւ̃|C^Ctr Xm[haltpɂ(4)ւ̃|C^i[D@n
ŏɌp^[̂ݕ]D
@code
	tp				tr
	  --> A (1)		  --> A 		A, B, X  L[l(ldat.key.buf)
	  --> B (2)		  --> X
	  --> A (3)
	  --> X (4)
	  --> A (5)
	  --> X (6)
@endcode
*/
tXML*  cmp_sisters_xml(tXML* tp, tXML* tr)
{
	tXML* ta;
	tXML* tb = NULL;
	tXML* ts;

	ts = tp;
	while (ts!=NULL){
		ta = ts;
		tb = tr;
		while (ta!=NULL && tb!=NULL) {
			// vȂꍇ break
			if (ta->ctrl==TREE_ALREADY_FOUND_NODE) break;
			if (tb->ctrl!=TREE_NOCMP_NODE && tb->ctrl!=TREE_NOCMP_COPY_NODE) {
				if ((ta->ldat).key.buf!=NULL && (tb->ldat).key.buf!=NULL) {
					if (ta->ldat.id!=tb->ldat.id || strcmp((char*)((ta->ldat).key.buf), (char*)((tb->ldat).key.buf))) break;
				}
				else break;
			}

			// ta  tb ͈v
			tb->altp = ta;
			ta = ta->ysis;
			tb = tb->ysis;
		}

		// ts  tr ͊SɈv
		if (tb==NULL) return ts;

		ts = ts->ysis;
	}

	return NULL;
}





//////////////////////////////////////////////////////////////////////////////////////
//
// Simple Tag Functions  (Pȍ\̃^Ȏ)
//

/**
Buffer  get_tag_content(tXML* tp, const char* name, int no)

tp XMLf[^ noԖڂ̃^O '<name>tag_content</name>' tag_content̃Rs[𓾂D@n
^ÕRegꍇ́Cŏ̃Reĝ݂ԂD

@param  no   v̒ŉԖڂ̕Ԃw肷D1琔D
*/
Buffer  get_tag_content(tXML* tp, const char* name, int no)
{
	Buffer content;
	tXML*  tt;
	
	content = init_Buffer();
	if (tp==NULL || name==NULL) return content;

	if (no<=0) no = 1;
	tt = strncmp_tTree(tp, name, 0, no);
	if (tt!=NULL) {
		if (tt->next!=NULL) {
			tt = tt->next;
			while (tt!=NULL && tt->ldat.id!=XML_TAG_CONTENT) tt = tt->ysis;
			if (tt==NULL) return content;
			content = dup_Buffer(tt->ldat.key);
		}
	}

	return content;
}



/**
int   get_tag_integer(tXML* tp, const char* name, int no)

tpXMLf[^ noԖڂ̃^O '<tag_name>tag_content()</tag_name>'  tag_content()𓾂D

*/
int   get_tag_integer(tXML* tp, const char* name, int no)
{
	int	   ret;
	Buffer content;

	content = get_tag_content(tp, name, no);

	if (content.buf==NULL) ret = 0;
	else				   ret = atoi((const char*)content.buf);
	free_Buffer(&content);

	return  ret;
}



/**
int   return_exist_tag(tXML* tp, const char* name, int no, Buffer* content)

buf̒ ^O '<name>content</name>' ݂邩ǂ`FbND
݂ꍇ͂̃^ÕReg̃Rs[ content Ɋi[CTRUE ԂD

*/
int   return_exist_tag(tXML* tp, const char* name, int no, Buffer* content) 
{
	Buffer buf;
	
	buf = get_tag_content(tp, name, no);
	if (buf.buf==NULL) return FALSE;

	if (content!=NULL) *content = buf;
	return TRUE;
}



/**
int  replace_all_tag_integer(tXML* tp, const char* name, int src, int dst)

XMLc[ pp ^O namełSẴ^ÕRegijCsrc dstɏD
			
@param  tp    uΏۂ̃c[
@param  name  us^Õ^O
@param  src   uΏۂ̃^ÕRegij
@param  dst   ũ^ÕRegij

@return um[h̐
*/
int  replace_all_tag_integer(tXML* tp, const char* name, int src, int dst)
{
	int  n;
	char nums[20], numd[20];

	snprintf(nums, 10, "%d", src);
	snprintf(numd, 10, "%d", dst);

	n = replace_all_tag_contents(tp, name, nums, numd);

	return n;
}



/**
int	 replace_all_tag_contents(tXML* pp, const char* name, const char* src, const char* dst)

XMLc[ pp ^O namełSẴ^ÕRegCsrc dstɏD
̃^Oɕ̃RegꍇɂΉD
			
@param  pp    uΏۂ̃c[
@param  name  us^Õ^ODNULL̏ꍇ͑SĂ̕D
@param  src   uΏۂ̃^ÕRegïꕔłjD NULL ̏ꍇ͑SĂ̕
@param  dst   ũ^ÕReg

@return u^O̐
*/
int	 replace_all_tag_contents(tXML* pp, const char* name, const char* src, const char* dst)
{
	int  n;

	if (pp==NULL || dst==NULL) return 0;

	if (pp->ldat.id==XML_ANCHOR_TAG) {
		if (pp->next!=NULL) pp = pp->next;
		else return 0;
	}
	while(pp->esis!=NULL) pp = pp->esis;

	n = replace_all_tag_contents_rcsv(pp, name, src, dst);

	return n;
}



/**
int	 replace_all_tag_contents_rcsv(tXML* pp, const char* name, const char* src, const char* dst)

replace_all_tag_content() ̕⏕֐

*/
int	 replace_all_tag_contents_rcsv(tXML* pp, const char* name, const char* src, const char* dst)
{
	int  n = 0;

	while(pp!=NULL) {
		if (pp->ldat.key.buf!=NULL && pp->ldat.id==XML_TAG_NAME && pp->ldat.lv>0) {
			if (name==NULL || !strcmp(name, (const char*)(pp->ldat.key.buf))) {
				tXML* tt = pp->next;

				// ̃Reg
				while (tt!=NULL) {
					if (tt->ldat.id==XML_TAG_CONTENT) {
						if (src==NULL) {
							copy_s2Buffer(dst, &(tt->ldat.key));
							n++;
						}
						else if (tt->ldat.key.buf!=NULL && strstr((const char*)tt->ldat.key.buf, src)!=NULL) {
							Buffer buf = replace_sBuffer_bystr(tt->ldat.key, src, dst);
							free_Buffer(&(tt->ldat.key));
							tt->ldat.key = buf;
							n++;
						}
					}
					tt = tt->ysis;
				}
			}
		}

		if (pp->next!=NULL) n += replace_all_tag_contents_rcsv(pp->next, name, src, dst);

		pp = pp->ysis;
	}

	return n;
}



/**
int	 replace_all_tag_byid(tXML* pp, const char* src, const char* dst, int id)

XMLc[ pp ^O̎ʂ idłSẴ^O̓e src dstɏD
			
@param  pp   uΏۂ̃c[
@param  src  uΏۂ̃^ÕRegïꕔłjD NULL ̏ꍇ͑SĂ̕
@param  dst  ũ^ÕReg
@param  id   uΏۂ̃m[hIDDid<0 ȂSẴm[h

@return u^O̐
*/
int	 replace_all_tag_byid(tXML* pp, const char* src, const char* dst, int id)
{
	int  n;

	if (pp==NULL || dst==NULL) return 0;

	if (pp->ldat.id==XML_ANCHOR_TAG) {
		if (pp->next!=NULL) pp = pp->next;
		else return 0;
	}
	while(pp->esis!=NULL) pp = pp->esis;

	n = replace_all_tag_byid_rcsv(pp, src, dst, id);

	return n;
}



/**
int	 replace_all_tag_byid_rcsv(tXML* pp, const char* src, const char* dst, int id)

replace_all_tag_byid() ̕⏕֐

*/
int	 replace_all_tag_byid_rcsv(tXML* pp, const char* src, const char* dst, int id)
{
	int  n = 0;

	while(pp!=NULL) {
		if (id<0 || pp->ldat.id==id) {
			if (src==NULL) {
				copy_s2Buffer(dst, &(pp->ldat.key));
				n++;
			}
			else if (pp->ldat.key.buf!=NULL && strstr((const char*)pp->ldat.key.buf, src)!=NULL) {
				Buffer buf = replace_sBuffer_bystr(pp->ldat.key, src, dst);
				free_Buffer(&(pp->ldat.key));
				pp->ldat.key = buf;	
				n++;
			}
		}

		if (pp->next!=NULL) n += replace_all_tag_byid_rcsv(pp->next, src, dst, id);

		pp = pp->ysis;
	}

	return n;
}




