
#ifndef  __JBXL_CPP_BVH_TOOL_H_
#define  __JBXL_CPP_BVH_TOOL_H_


#include  "xtools++.h"
#include  "bvh_tool.h"
#include  "Vector.h"
#include  "Rotation.h"





//
#define  BVH_ERR_FAIL_WRT_MOTION	-1		// [Vf[^̏ݎs
#define  BVH_ERR_FAIL_WRT_HIRCHY	-2		// WCgf[^̏ݎs
#define  BVH_ERR_FAIL_FOPEN			-3		// t@C̃I[vɎs
#define  BVH_ERR_INVLD_ARGS			-4		// sȈi͒lj
#define	 BVH_ERR_FAIL_OP			-5		// s







namespace jbxl {





class  CBVHTool : public BVHData
{
public:
	CBVHTool(void)  { init();}
	virtual ~CBVHTool(void);


public:
	//
//	int				joint_num;		// WCg̐
//	int  			frame_num;		// t[̐
//	double			frame_time;		// t[Ԃ̎ sec
//	int				framepsec;		// FPS = (int)(1.0/frame_time)
//	int  			channels;		// `lD`l̍vD[Vf[^̐D
//	int				state;			// f[^̏
	
//	tTree*			hierarchy;		// WCg̃c[f[^ւ̃|C^DLQƁD
//	double*			motion;			// MOTION f[^ւ̃|C^ joint_num*frame_num
//	vector*			offset;			// WCgOFFSET

//	Buffer*			joint_name;		// WCg̖O̔z


public:
	//
	void			init(void);
	void			free_data (void);
	void			clear_data(void);

	void			copy_bvh_data(BVHData* bvh);
	BVHData			setback_bvh_data(void);

	BOOL			readFile (char* fname);
	BOOL			writeFile(char* fname);
	BOOL			writeMultiFile(char* fname, int sec, int space);
	
	BOOL			readBVH (FILE* fp);
	BOOL			printBVH(FILE* fp);

	void			setHierarchy(tTree* hrchy);


	Vector<double>* getPosOffset(void);
	Vector<double>*	getPosData(int frame);
	Quaternion*		getQuaternion(int frame);

//	Matrix<double>*	getRotMatrix(int frame);


//
private:
public:
	//
	Buffer*			joint_name;		// WCg̖O̔z
	int*			channel_num;	// eWCg̃`l
	int*			channel_idx;	// eWCg̃`l̈ʒui݌vj
	Buffer			flex_joint;		// eWCg̃`l  ex) "PXPYPZRXRYRZRXRYRZ...."


private:
	//
	void			set_offset(void);
	void			_set_offset(tTree* tree, int* jnum);

	void			get_bvh_params(void);
	void			_get_bvh_params(tTree* tree, int** ch, Buffer** jn);
};





}		// namespace

#endif
